Last Comment Bug 201307 - slow scrolling in pages with position:fixed elements
: slow scrolling in pages with position:fixed elements
Status: RESOLVED FIXED
: perf, regression, testcase
Product: Core
Classification: Components
Component: Layout: View Rendering (show other bugs)
: Trunk
: All All
: -- normal with 123 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
:
Mentors:
: 222844 249880 264630 268683 271573 273064 280794 394005 455667 474183 496786 (view as bug list)
Depends on: 90198 372039
Blocks: 100951 242364 198964 203448
  Show dependency treegraph
 
Reported: 2003-04-09 00:40 PDT by John McCormick
Modified: 2013-11-27 05:48 PST (History)
92 users (show)
asa: blocking1.7.6-
asa: blocking1.8b-
asa: blocking‑aviary1.5-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
a testcase which let you choose 'fast scolling mode' and 'slow scrolling mode' :) (5.86 KB, text/html)
2003-04-23 00:42 PDT, Chu Alan "sprite"
no flags Details
similar patch isolating position:fixed from the scrollbar overdraw (6.25 KB, text/html)
2003-04-25 18:55 PDT, John McCormick
no flags Details
shows various scrolling speeds/states (7.52 KB, text/html)
2003-10-14 21:26 PDT, John McCormick
no flags Details
shows performance differences for fixed/non-fixed scrolling (8.67 KB, image/png)
2003-10-14 21:28 PDT, John McCormick
no flags Details
test demonstrating affect of multiple fixed elements (8.62 KB, text/html)
2004-01-26 08:32 PST, miahz
no flags Details
testcase with 100 fixed elements (10.27 KB, text/html)
2005-01-09 12:55 PST, Peter van der Woude [:Peter6]
no flags Details
transparent image for next testcase (93 bytes, image/gif)
2005-01-10 12:11 PST, Peter van der Woude [:Peter6]
no flags Details
Testcase with 100 fixed transparent images (10.32 KB, text/html)
2005-01-10 12:15 PST, Peter van der Woude [:Peter6]
no flags Details
Testcase that shows how the fixed elements should act (10.45 KB, text/html)
2005-08-11 20:23 PDT, jfftck
no flags Details
Firefox 3b3 very very slow scrolling!!! (Firefox 2 scrolling fast) (25.92 KB, text/html)
2008-02-16 04:42 PST, Marek Chlup
no flags Details
Firefox 3b3 very very slow scrolling!!! (Firefox 2 scrolling fast) (102.89 KB, text/html)
2008-02-18 02:02 PST, Marek Chlup
no flags Details
Demonstration: html file with big tables + css file (4.72 KB, application/x-rar-compressed)
2008-04-14 03:57 PDT, Johan Douma
no flags Details
Simple test case with plenty of fixed divs (requires js.) (1.69 KB, application/xhtml+xml)
2008-05-26 15:15 PDT, Unknown W. Brackets
no flags Details
a bit of position:fixed element and a bunch of resized images (2.30 KB, text/html)
2008-06-26 07:14 PDT, kataho.mail
no flags Details
testcase from real-world intranet with just one fixed div (18.41 KB, text/html)
2008-12-27 17:37 PST, Michael Balzer
no flags Details

Description John McCormick 2003-04-09 00:40:05 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.4a) Gecko/20030408 Phoenix/0.5+
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.4a) Gecko/20030408 Phoenix/0.5+

I discovered this is the site listed above. To verify this, I've visited several
sites in which a certain element can be set to have a position of either fixed
or relative--in all cases, so far, scrolling performance significantly decreases
when the element has a position of fixed. An easy example case follows:

Reproducible: Always

Steps to Reproduce:
10 Go to http://texturizer.net/phoenix/themes.html
20 Scroll -- speed is normal. 
30 Move your mouse over the navigation menu.
40 "Lock Menu" should appear at the top of the menu. Click it.
50 Scroll -- speed is slow, very jerky.
60 Move your mouse over the navigation menu.
70 "Unlock Menu" should appear at the top of the menu. Click it.
80 GOTO 20: REM ^_^



This may be related to Bug 90198, but doesn't quite fit its direction. Bug 98252
also seems like it _could_ be related. 

I'm not sure how well I've isolated this, but it seems that on pages including
fixed elements, scrolling is slowed considerably. Smooth-scroll, in particular,
can be very bad. Presently, I've focused on the CSS 'position: fixed' part of
this problem, but especially at the listed URL, there may be other nefarious
things at work.
Comment 1 Hermann Schwab 2003-04-09 04:17:45 PDT
WFM Mozilla/5.0 (Windows; U; Win98; en-US; rv:1.4b) Gecko/20030408

Product should be PHOENIX
Comment 2 Hermann Schwab 2003-04-09 04:28:56 PDT
WFM Mozilla/5.0 (Windows; U; Win98; en-US; rv:1.4a) Gecko/20030408 Phoenix/0.5+
Athlon XP1600+ nForce 
Comment 3 Jo Hermans 2003-04-09 07:44:52 PDT
Well, I though it was a well-known problem, and I've seen it lots of times. I've
removed the fixed background on my website because of this. For me it's a dupe
of bug 90198.
Comment 4 Hermann Schwab 2003-04-09 10:37:13 PDT
WFM Mozilla/5.0 (Windows; U; Win98; en-US; rv:1.4b) Gecko/20030408
Celeron 333 MHz 96 MB Ram, SiS6326 Graphicscard (8 MB)

With this computer I see a difference in scroll speed, but speed is reasonable
fast in both cases. Both computers 800x600. But with both computers I had to
wait long, till all images from Phoenix Help were loaded.
On the w3.org testpage I didn´t see a remarkable effect, wouldn´t have noticed
slowness.
Comment 5 Jo Hermans 2003-04-09 13:57:47 PDT
Actaully, for this particular page, it's a WFM (build 2003040910 on Mac OS X
10.2.4), even on my old 300 MHz iBook. The smooth-scrolling is the biggest
contributing factor. We've progressed immensily the last few months.

BTW: most of the urls in bug 90198 are about a fixed background. This bug is
about fixed positioning, and I think it's a dupe of another bug.
Comment 6 John McCormick 2003-04-09 19:21:01 PDT
For reference: 
Athlon 800Mhz (384MB PC100)
GeForce4 Ti 4400 (128MB DDR)

After seeing the WFM comments, I checked the pages again to see if I was crazy.
I got no significant slowdown, and couldn't figure out why. I think I'm getting
there, though. I've done some more testing, and am downloading a mozilla nightly
to see if this is phoenix-specific. 

I am able to reproduce the problem by having certain other programs running
(though idle) at the same time as Phoenix. It seems to be a very binary thing;
either scrolling is seriously hampered, or it isn't. (And, well, yes--fixed
elements slow down a page even when this problem isn't present, but not by
nearly as much.) This reminds me of comments 18-22 or so in Bug 90198. 

The program that causes the slowdown, on my machine, is a java-based text editor
(jEdit; http://www.jedit.org/). Any time it is open, the problem is present on
pages with fixed elements. Other pages seem unaffected, but that may be just
because of the inherent performance differences. 

Additionally, (and this is strange) if I set the windows Task Manager to display
as 'always on top', and leave it over a page without fixed elements, that page
suffers from the same performance drop that pages with fixed elements do. This
seems to be less true of Winamp and the windows CD player, perhaps because they
take up less screen-space. That seems like it could be windows-specific; has
anyone encountered this in unix/linux? 

Additionally, can anyone recommend some other java-based GUI programs to test
against?
Comment 7 John McCormick 2003-04-09 19:33:23 PDT
just adding that I've confirmed I run into the problem in Mozilla as well as
Phoenix.
Comment 8 José Jeria 2003-04-10 00:53:24 PDT
I see the choppy scrolling, but that happends with and without the menu being
fixed. Also blocking the images (remove background image) doesnt help. It gets
choppy in the top, where all the thumbnails are.
Comment 9 John McCormick 2003-04-10 03:33:25 PDT
I've noticed that as well, but it's a different issue. If you are encountering
this, it'll be pretty drastic, and bad even down below the big image grid.
Comment 10 Stefan Borggraefe 2003-04-22 17:10:05 PDT
Marking NEW to get this somewhere. I couldn´t find a bug that explicitly deals
with fixed elements in general. I´m adding a dependency to bug 90198 which is
about fixed backgrounds.
Furthermore I believe this should block Bug 198964 ("Enable/disable smooth
scroll by default") since this bug is much worse when smooth scrolling is enabled.
Comment 11 Chu Alan "sprite" 2003-04-23 00:42:54 PDT
Created attachment 121395 [details]
a testcase which let you choose 'fast scolling mode' and 'slow scrolling mode' :)

I have discovered offscreen fixed div will make scrolling slow, however, if the
fixed div is in the document entirely, scolling speed is acceptable.

I hope this helps :)
Comment 12 Chu Alan "sprite" 2003-04-23 00:52:10 PDT
On Firebird the fixed div will overpaint the scrollbar everytime the document is
scrolled, furthermore, I have tried to change it to offset to -10px to avoid
scrollbar repaint (which may account for scrolling slowness), but the scrolling
is still slow.

The slowdown is more apparent when you use 'up' or 'down' cursor key on your
keyboard to scroll :)
Comment 13 Robert O'Callahan (:roc) (email my personal email if necessary) 2003-04-23 12:01:36 PDT
That is extremely helpful. Thanks!
Comment 14 Chu Alan "sprite" 2003-04-24 02:35:06 PDT
roc+moz: I have just tested my testcase in (not so) nightly mozilla build on
Linux, and it seems that the problem is not as apparent, if there is any slow
downs at all, as my gtk2 phoenix build (which uses XP scrollbar...), so I
suspect my testcase is deomonstrating another problem other than general
slowness (or I have broken my source tree).
Comment 15 Chu Alan "sprite" 2003-04-24 04:10:05 PDT
roc+moz: I have tried my testcase on Phoenix GTK2, Phoenix GTK nightly
(20030423) and Mozilla nightly (mentioned in prev. comment, 2003042307).

result: 
1. my testcase
1a Phoenix GTK2: slows down (as exptected), red div overpaint on XP scrollbar.
1b Phoenix nightly (GTK): no slow down, however, red div still overpaint on GTK
scroll bar
1c Mozilla: no apperant scrolling slowdown, no red div overpaint, works perfectly.

2. texturizer theme page: 
2a,b,c all three browser exhibits same problems: 
1) it takes me a few clicks to get the menu locked.
2) mouse wheel is unable to scroll the page after the menu is locked (by 2+
clicks), until I have clicked empty area on document.
3) scrolling is slow, jerky, blah blah blah... after the menu has been locked.
Comment 16 John McCormick 2003-04-25 18:02:42 PDT
-> Chu: Thanks so much for doing the heavy lifting here! I feel very bad about
abandoning the bug for two weeks...

Based on comment 15, I've downloaded mozilla 1.4a (Mozilla/5.0 (Windows; U;
Windows NT 5.1; en-US; rv:1.4a) Gecko/200304010) and tested the attachment in it
as well as phoenix: 

On my system (was Win2k, now WinXP), /both/ Firebird and Navigator have /both/
the slowdown and the scrollbar overpaint. Perhaps this is a windows/linux
difference somewhere in the lower level stuff?
Comment 17 John McCormick 2003-04-25 18:55:55 PDT
Created attachment 121753 [details]
similar patch isolating position:fixed from the scrollbar overdraw
Comment 18 John McCormick 2003-04-25 19:20:32 PDT
Actually, now that I'm looking at this, there seem to be as many as three bugs here:

(1) Like in the bug's name, any pages with fixed elements scroll noticeably
slower than  those without such elements. The second patch illustrates only this
bug. Additionally, on Windows2k/XP, I can duplicate this behavior on a page
without fixed elements (such as either attachment in 'fast' mode) by having an
'always on top' window overlapping the browser window. Can this be checked in linux?

(2) In the case that such a fixed element is displayed partially offscreen, two
things happen: (i) scrolling slows drastically, and (ii) the element can
overdraw the scrollbar.

(3) This is the bug I was initially encountering/reporting, and can no longer
reproduce. While running the program jEdit 4.01, mozilla/phoenix were scrolling
at speeds of around 5-6 px/second on pages with fixed elements. If I encounter
this again, I'll make a new, more specifically targeted (and better tested!) bug.

As it stands, I think it'd be best to focus on the first of these here, perhaps
make a new bug for the second if it's unrelated, and drop the third entirely.
Comment 19 Markus Hübner 2003-05-12 08:55:05 PDT
Don't we already have a bug for point 2?!
Comment 20 John McCormick 2003-07-01 15:13:07 PDT
just adding some comments based on my experience in the past few weeks.

In both Mozilla and Firebird, scrolling-speed is reduced on Windows platforms if
either of the following conditions exist:

1) The page contains a fixed element. 
2) Another window (set in 'always on top') is partially or wholly on top of the
browser window. (Winamp, Task Manager, etc...)

The more fixed elements present (including windows 'on top' of the browser), the
more noticeable this slowdown is. 

Other comments:

I'm still thinking this may be specific to windows, and perhaps how mozilla
paints itself under the OS. Can anyone cross-test this between windows/linux or
windows/OS X? I don't really have access to linux machines or non-uberfast OS X
machines. 

I've tried to see how IE behaves, but can't get mine to display anything other
than backgrounds as fixed. Having windows on top of the IE window doesn't seem
to affect its scrolling speed at all, though. 

Recent builds of Firebird slow down _much_ less than before. Neither test case
produces a noticeable slowdown at all on my Athlon 500. The texturizer page is
only barely choppy. What changed?
Comment 21 John McCormick 2003-08-25 15:58:39 PDT
Just switched to the 25 August nightly of Firebird (from 6.1) and noticed that
things have slowed back down. A lot.

Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.5b) Gecko/20030825 Mozilla
Firebird/0.6.1+
on Windows 2000
Athlon XP 2100

Mozilla/5.0 (Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.5b) Gecko/20030825
Mozilla Firebird/0.6.1+/jtalkington-nightly
Power Mac G4
Dual processor system.

Anyway... this shows up both on Windows and OS X, so I'm betting Linux/Unix have
it too. Curiously, though, on Mac OS, having transparent or hovering windows
doesn't have much to do with it.
Comment 22 John McCormick 2003-10-14 21:26:05 PDT
Created attachment 133309 [details]
shows various scrolling speeds/states

Per comment 19, I looked for other bugs for chu alan's test case and turned up
bug 186696 and bug 183495, but those both seem to focus on the scrollbar paint,
rather than the slowdown. I've made a new bug 222198 for this problem. 

I'm adding an attachment to this bug allowing tests for scrolling normal,
fixed, and the above case where fixed elements are too big. Performance tests
for this page follow.
Comment 23 John McCormick 2003-10-14 21:28:21 PDT
Created attachment 133310 [details]
shows performance differences for fixed/non-fixed scrolling

For this bug, I ran some performance tests to show better what I'm talking
about. While the slowdown on account of fixed elements (or a hovering window)
is hard to notice on my now fast machine, the difference in CPU use (and thus
for the user on slower machines) is very drastic! Other browsers do this much
more gracefully, so something's probably wrong.
Comment 24 John McCormick 2003-10-15 08:53:31 PDT
Just downloaded Mozilla 1.5 and Firebird 0.7, and suddenly this is WFM -- CPU
use in all cases is below 10%, and scrolling's beautiful (apart from the
scrollbar overpaint). 

The 1.5 Release notes said something about fixing windows GDI paint problems.
Maybe that's what this problem was? That'd make sense given the fact that having
a non-mozilla window hovering over the mozilla window caused the same problem.
What bug was that?
Comment 25 Chu Alan "sprite" 2003-10-18 10:13:42 PDT
before closing this bug (and other related bugs), please have somebody check 
other platforms as well

BTW from my distant memory, slow down occurs on GTK/Linux as well...
Comment 26 Greg Campbell 2003-10-18 11:55:17 PDT
Definitely not WFM! Scrolling is still quite slow for me on pages with fixed
elements. The attachment (id=133309) (shows various scrolling speeds/states) is
no different between the "fixed menu" and "huge fixed menu" however.

Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.6a) Gecko/20031017
Firebird/0.7+ (aebrahim)
Comment 27 Markus Hübner 2003-11-20 05:27:33 PST
The testcase you mentiond is WFM with Mozilla/5.0 (Windows; U; Windows NT 5.1; 
en-US; rv:1.6a) Gecko/20031028
Maybe this is due to graphic driver related problems too? 
Comment 28 José Jeria 2003-11-20 06:00:09 PST
See Bug 222844 (a dupe i think), where reporter says position fixed is slower
with anti-aliased fonts.
Comment 29 fondacio 2003-11-20 12:59:37 PST
To elaborate on comment #27: I suspect the graphics driver are relevant. I
recently replaced my Kyro-based card (Hercules Prophet 4000XT 32 MB TV-out) with
a GeForce2-based card (MX440; 64 MB) and page rendering generally appears to be
faster on some sites and this bug hardly appears anymore. The testcase scrolls
the same at both speeds. A site that used to be notoriously slow and has become
bearable, albeit still a bit slow, is djst's weblog:
http://weblogs.mozillazine.org/djst/
That page might still serve as a useful testcase.

Mozilla/5.0 (Windows; U; Win98; en-US; rv:1.5) Gecko/20031007

Comment 30 bugzilla2005 2003-11-22 16:52:59 PST
*** Bug 222844 has been marked as a duplicate of this bug. ***
Comment 31 Florian 2004-01-21 08:08:28 PST
http://www.lesproviders.com is very slow here. Firebird 0.7, Windows XP SP1,
PIII 1gh 256ram geforce2.
Comment 32 José Jeria 2004-01-21 08:14:18 PST
Perret, the page you mention does not have any element with position:fixed,
thats what this bug is about.

Both the testcases and the URL scrolls are WORKSFORME with Firebird 0.8 branch
build 20040120.
Comment 33 Zibi Braniecki [:gandalf][:zibi] 2004-01-21 11:57:43 PST
Also WFM with Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.6b) Gecko/20031218
Firebird/0.7+
Comment 34 Kai de Leeuw 2004-01-21 12:14:33 PST
WFM 
Mozilla 1.6 
Win XP SP1 
ATI Radeon 9700 TX
P4 2.53 Ghz
Comment 35 Marcos Francesconi 2004-01-22 12:20:59 PST
#32:
>Perret, the page you mention does not have any element with position:fixed,
>thats what this bug is about.

Actually, it does. Open
http://www.lesproviders.com/themes/L12_lesproviders/style.css and and you'll see:

<blockquote>background: White url(images/fond.jpg) no-repeat fixed top
left;</blockquote>

And to make things worst, it's a <a
href=http://bugzilla.mozilla.org/show_bug.cgi?id=90198>fixed background</a>.

I'm running "Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.5)
Gecko/20031007 Firebird/0.7" and scrolling is painfully slow here too.

ps: btw, is the above CSS declaration a valid one? It isn't supposed to be a
"background-attachment: fixed;" somewhere?
Comment 36 Marcos Francesconi 2004-01-22 12:24:31 PST
I screwed big time in my previous post. Didn't know HTML wasn't supported.

Sorry!
Comment 37 miahz 2004-01-26 08:32:46 PST
Created attachment 139911 [details]
test demonstrating affect of multiple fixed elements

while working on a page design, i noticed that the number of position:fixed
elements affected the scroll speed, which led me to look up this bug.  at first
it seemed like any number more than one would cause a serious slow down, but
after creating and playing with this test, i'm not so sure.

it's based off the previous attached tests, but has 5 elements that can be
locked and unlocked individually.  there is a definite deterioration of
performance with multiple fixed elements.  the most noticeable way i've found
to test it is to turn on smoothscroll, and use the keyboard arrows one line at
a time.  with everything unlocked, it scrolls almost instantly.  lock one box,
and it slows down noticeably, but not terribly.  each additional locked box
seems to slow it down more.  another way to test is to hold down the arrow key
then see how much it "coasts" after you release.  with all unlocked it should
stop instantly.

tested in firebird 0.6.1 and 0.7 on windows 2000 sp3, pII 400mhz, 384mb ram,
16mb agp riva tnt.  haven't touched a new build since 0.7, so i couldn't
comment on the recent WFMs.  my computer is 5 years old now, and i wouldn't be
suprised if any newer computer with sufficient horsepower never saw these
problems.

while testing, i also uncovered another issue:
increasing the text size (CTRL +) with fixed boxes destroys performance even
more.  oddly, decreasing it doesn't seem to have an effect.  not sure if this
is a general thing or something unique to these testcases.
Comment 38 José Jeria 2004-02-17 15:32:08 PST
Can anyone reproduce this with a new build and a page that actually uses
position:fixed?
Comment 39 Greg Campbell 2004-02-17 15:54:52 PST
http://www.w3.org/Style/Examples/007/scrollbars.html - scrolls at about half the
speed of a page without fixed elements.

http://firefox.bric.de/index.php - pick the "fixed menu" stylesheet; scrolls
maybe 25% of normal speed.

Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7a) Gecko/20040210
Firebird/0.8.0+
Comment 40 John McCormick 2004-02-17 21:16:44 PST
My system is fast enough at this point that I don't ever _notice_ encountering
this bug. Apparently I still do, though. On this page, and on the two Greg
mentioned, I tried measuring CPU load while scrolling by holding down the arrow
keys:

On this page, CPU use capped at ~10%
On both other pages, CPU use capped at ~80%

Both appear fine from my viewpoint, but obviously mozilla's working a lot harder
when fixed elements are involved.

Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.6) Gecko/20040206 Firefox/0.8
Comment 41 Rene Pronk 2004-03-07 09:57:16 PST
In reply to #38, yes this bug is still very noticable. If you go to
http://www.tweakers.net and scroll from the bottom up you'll see sluggish
scrolling at the top of the page. It uses many abs. positioned DIV's, some are
hidden some are not so the slow scrolling may be a combination of this bug and
bug 203439 - slow scrolling due to hidden, fixed-position elements, although the
latter probably depends on this one.
Comment 42 Stefan Borggraefe 2004-10-16 06:43:09 PDT
*** Bug 264630 has been marked as a duplicate of this bug. ***
Comment 43 Ian Neubert 2004-10-27 12:07:24 PDT
I'm seeing this in Linux as well, I'm running Xorg 6.8.0 and dual monitors with
Xinerama. 

Mozilla/5.0 (X11; U; Linux x86_64; rv:1.7.3) Gecko/20040929 Firefox/0.10.1
Comment 44 Benjamin Streeck 2004-10-28 05:29:27 PDT
This is basically one of last major problems of the Gecko engine. Looking at
Opera 7.6 they seem to have fixed all their speed-related problems in Presto.
For me, this makes smooth scrolling not usable, which is quite sad I find.

(FYI: This page is the best (worst) example I've found showing the problem:
http://www.streeck.com/homepage.html )

Occurs in Win2k and WinME: Fx 0.10.1, Fx 1.0rc1, Moz 1.7.3, Moz 1.8a4
Comment 45 Matt 2004-10-31 14:41:13 PST
Oh boy, you don't want to see what it looks like when you position:fixed; a
flash or shockwave object; CPU usage goes out the window at over 50% on a P4C
clocked 3.09 GHz, 1 gig RAM, GeForce FX 5900. You'd think that my box could
handle this, but it's definitely a bug.

Demonstration of flash/whatever: http://www.bungie.net
At least they plan on changing the site when Halo 2 comes out, but this is still
an annoying bug.
Comment 46 Nemanja Dubravac 2004-11-08 16:01:32 PST
this bug was opened 2003-04-09
whats so special about it that cant be fixed in more than a YEAR?

i have a P4 2.8, 512 DDR, ATI Radeon mobility (64 DDR) and scrolling is still
too slow!
btw, this bug isnt only for win2k.. i use xp
Comment 47 José Jeria 2004-11-11 00:27:44 PST
*** Bug 268683 has been marked as a duplicate of this bug. ***
Comment 48 Ryan VanderMeulen [:RyanVM] 2004-11-11 07:01:24 PST
http://www.warp2search.net/ also exhibits this problem. I've experienced the
issue with Windows XP SP1 & SP2 and Windows 98. This is an issue for more than
just Windows 2000.
Comment 49 Asher 2004-11-13 11:44:54 PST
This isn't just a Win2K bug, it's also evident on Windows XP and Linux.  Not
sure about other platforms -- assuming they are also affected.

This is starting to become a very high profile bug, one that has turned off at
least one person I know from Firefox.  I got him to switch with 1.0PR, but he's
into Halo 2 (as a huge number of my friends now).  With the way Bungie.net is
designed (a very central part to Halo 2's multiplayer), it's painfully slow in
Firefox and fine in IE.  
Comment 50 David E. Ross 2004-11-14 16:47:52 PST
This might be a symptom of bug 124150.  See my comment 66 in that bug.  
Comment 51 Olivier Cahagne 2004-11-24 12:21:16 PST
*** Bug 271573 has been marked as a duplicate of this bug. ***
Comment 52 Osman 2004-11-24 18:32:24 PST
Those who play Halo 2 on Xbox Live usually go check their stats on Bungie.net
(http://www.bungie.net/stats/) and by "Those" I mean this:

Halo 2 - Xbox Live Statistics
(last 24 hrs)
Unique Players:  	351,639
Matches Logged: 	802,034
Players Online:  	71,505

Hopes you guys can fix that soon, because it's getting pretty big now. Sorry
that I can't help. :/
Comment 53 Martijn Wargers [:mwargers] (not working for Mozilla) 2004-11-25 01:31:22 PST
*** Bug 249880 has been marked as a duplicate of this bug. ***
Comment 54 jfftck 2004-12-01 18:48:01 PST
I am using the User Agent Switcher and set my agent string to Mozilla/4.0
(compatible; MSIE 6.0; Windows NT 5.1) and the bungie.net stats page scrolls
much better. I am using Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US;
rv:1.7.5) Gecko/20041107 Firefox/1.0. But the page is still slow, but now it is
useable now.
Comment 55 Martijn Wargers [:mwargers] (not working for Mozilla) 2004-12-04 05:51:37 PST
*** Bug 273064 has been marked as a duplicate of this bug. ***
Comment 56 Grayson Mixon (ColdFusion650) 2005-01-08 08:55:10 PST
seems to be fixed in 2005-01-08-07-trunk
Comment 57 Peter van der Woude [:Peter6] 2005-01-08 09:55:18 PST
Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8a6) Gecko/20050107
Firefox/1.0+

I tried this attachement 
https://bugzilla.mozilla.org/attachment.cgi?id=139911

definitly NOT wfm
Comment 58 Grayson Mixon (ColdFusion650) 2005-01-08 10:04:50 PST
maybe it doesnt work for u because ur using yesterdays build, and it was only
fixed today. thats why i said it was fixed as of 2005-01-08-07-trunk. ur using
2005-01-07-?-trunk.
Comment 59 Peter van der Woude [:Peter6] 2005-01-08 11:03:42 PST
(In reply to comment #58)
> maybe it doesnt work for u because ur using yesterdays build, and it was only
> fixed today. thats why i said it was fixed as of 2005-01-08-07-trunk. ur using
> 2005-01-07-?-trunk.

Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8a6) Gecko/20050108
Firefox/1.0+

WFM 

All testcases are fast

My stupidity,used the wrong build before

Comment 60 Peter van der Woude [:Peter6] 2005-01-08 11:26:21 PST
All checkins between 20050107 and 20050108 Win builds

bug 259126 [Firefox]-sites/exceptions list allows invalid hostnames [Win]
bug 187508 [Core]-Follow "full keyboard access" setting in System Preferences
for tabbing navigation [Mac]
bug 250276 [Core]-right-click, cut of BM inside folder inside PT crashes [@
nsMenuPopupFrame::SetCurrentMenuItem ] (aviary) [Lin]
bug 275828 [Toolkit]-#ifdef MOZ_THUNDERBIRD statements in Extensions Manager
hose Sunbird [All]

One of these must have fixed something...
Comment 61 Greg Campbell 2005-01-08 21:29:39 PST
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8a6) Gecko/20050108
Firefox/1.0+

I checked the testcases and they are close, but I still notice a subtle
slowdown. I recently upgraded my motherboard and processor and all the
fixed-element slowdowns got significantly better from the hardware upgrade.

Someone with an older/slower machine should test this since that's where the
slowdown is most noticeable.
Comment 62 A. Klitzing 2005-01-09 04:46:01 PST
Mozilla/5.0 (Windows; U; Windows NT 5.0; de-DE; rv:1.8a6) Gecko/20050108
Firefox/1.0+

I still have slowdown with the testcases. But it is faster then my 
Mozilla/5.0 (Windows; U; Windows NT 5.0; de-DE; rv:1.8a5) Gecko/20041122

P2 450 Mhz
Comment 63 José Jeria 2005-01-09 04:56:57 PST
www.bungie.net is still slow for me, latest trunk build, Windows XP, Pentium 4,
3,2 ghz, ATI Radeon 9800XT
Comment 64 Grayson Mixon (ColdFusion650) 2005-01-09 09:33:31 PST
mine scrolls fine

Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8a6) Gecko/20050109
Firefox/1.0+
Windows XP Home SP2
Pentium 4 2.53 GHz
80 GB HD
512 MB DDR Ram
ATI Radeon 9200 128 MB
Comment 65 John McCormick 2005-01-09 10:39:03 PST
About all the recent WFM comments:

1) If you're testing this with a relatively new machine, pull your task manager
up and check CPU usage. You may be surprised how much is going on, even if you
can't see it. See Comment 40.

2) Back when I was really trying to isolate this bug, it seemed like it only
started showing up after a certain something happened--fine up to a point, and
then suddenly slow--but I could never find out what that something was. 

For what it's worth, the bungie site is still ridiculously slow for my machine
using Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8a6) Gecko/20050107
Firefox/1.0+

Should we update the URL to http://www.bungie.net/, since the w3c scrollbar site
doesn't (visibly) show this bug on most people's machines?
Comment 66 John McCormick 2005-01-09 10:45:06 PST
Just noticed I was using the build you were complaining about, ColdFusion.
Unfortunately, I still get this even with today's build.

Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.8a6) Gecko/20050109
Firefox/1.0+
Comment 67 Peter van der Woude [:Peter6] 2005-01-09 12:55:52 PST
Created attachment 170761 [details]
testcase with 100 fixed elements

Roughly the same testcase as before, just simpler, but with 100 fixed elements.

( after discussion what causes http://www.bungie.net/ to still be slow )
Comment 68 Grayson Mixon (ColdFusion650) 2005-01-09 14:33:16 PST
i have a fast computer, and on the regular test cases, it scrolls fine and the
cpu usage is at 2% (which a bunch of other programs running). the one with 100
fixed elements scrolls somewhat slower. barely noticable, and still only 2% cpu
usage. it seems that the new builds only minimize the affect of the fixed elements.
Comment 69 Joël Kuiper 2005-01-10 10:30:58 PST
the tescase with 100 fixed elements scrolls notably slower on my pc (P4 1,6Ghz;
512MB DDR-RAM) with 20050110 Firefox/1.0+ . But if we look practicly 
http://www.bungie.net/ is a site with over 30 fixed items, you can hardly call
that efficient coding. So you might wonder if the slow behavior of FF is not the
webdesigners fault
Comment 70 Peter van der Woude [:Peter6] 2005-01-10 12:11:53 PST
Created attachment 170842 [details]
transparent image for next testcase
Comment 71 Peter van der Woude [:Peter6] 2005-01-10 12:15:03 PST
Created attachment 170843 [details]
Testcase with 100 fixed transparent images

Wanna see slow.... ?
Comment 72 miahz 2005-01-10 14:01:44 PST
I see no noticeable difference between 1.0 and 20050110 on my 400MHz pII, 384MB
RAM, 16MB Nvidia TNT running at 1024x768x32.

For me the Bungie site is 2-3x slower than the "100 fixed transparent images"
test with either build, taking about 10 seconds per "scroll."
Comment 73 Brandon Knitter 2005-01-15 11:24:56 PST
User Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5)
Gecko/20041107 Firefox/1.0

I'm noticing HORRIBLE performance in general with FireFox.  I remember this back
in the Mozilla 1.6 days.  It turned out to be a memory leak on that issue.  When
running Horde (www.horde.org -- a web based mail client) the site refreshes
every 5 mintues.  I'm just guessing here, but perhaps the meta refresh, or
javascript refresh, just isn't releasing the memory from the previous page.

After leaving my laptop (2.4 gHz w/ 1G memory) running for 24 hours, refreshing
away at my.yahoo.com and Horde, FireFox will gobble up almost 300M of memory. 
Making it perform /really/ badly.  On numerous occasions I've even had to just
kill the process.

I'm not sure how to provide debug information on what's being gobbled up, but
I'd happily perform some debug steps/logging for anyone whom needs it.

Cheers!
Comment 74 henktiggelaar 2005-01-17 14:47:47 PST
I visited a site today which pretty much brought my Firefox to it's knees
(20050117). I made a <a href="http://www.n3t.nl/mozbug/">minimal tescase</a> and
found something weird.

When I was making the testcase with Dreamweaver MX 2004 I found out the
scrolling speed improved. Closing Dreamweaver made it go slow again. Even after
I restarted my computer this behavior continued (having Dreamweaver open in the
background / minimized improved the scrolling speed of this page in Firefox).
Can anybody who has Dreamweaver MX 2004 confirm this? 
Comment 75 Ger Teunis 2005-01-18 02:20:29 PST
Testcases are still slow here too.
Perhaps the bug 265610 is getting duped now by the widening of this bug
(transparant images).
Comment 76 Stefan Borggraefe 2005-02-02 13:21:19 PST
*** Bug 280794 has been marked as a duplicate of this bug. ***
Comment 77 Matt 2005-02-22 06:29:07 PST
Alright, not only is there a significant rise in CPU usage [still], there is
most likely a memory leak along with it.  If I recall correctly, multiple tabs
or subsequent viewings of pages such as bungie.net have an after-effect of
larger memory usage (and commit charge? it doesn't seem to use the memory it
creates, hinting at a leak).  I'd recommend somebody make some memory dumps of
Firefox for scrolling on a normal page (like this one) and ones for pages with
massive amounts of overhead-inducing elements (such as bungie.net).

Also, if anyone could test this using a debug version of FF (enable/create the
debugs for any possible pages that include the code that may be inducing this)
and check back with us.

We should also try to find any other programs that improve or lag the
performance while doing so.  This may seem like a bit of work to do (it is if
you're not used to debugging things...), but the fact that we haven't found what
is actually causing this bug yet after _almost_2_years_ calls for some major
hacking.

Primary areas to check: anything to do with page drawing, including the XUL bits
and CSS-related bits.  Also, check the JavaScript core pages that include the
functions used to simulate position-fixed scrolling and the frameset-related
core bits as these two methods of pseudo position-fixed elements appear to work
in a more orderly and optimized manner.

~Matt

Also, would Mr. McCormick please add an alias to this bug, maybe
"position-fixed"?  Thanks.
Comment 78 Caleb 2005-04-10 13:10:35 PDT
What about this page:
http://www.euronet.nl/users/frankvw/rants/microsoft/IhateMS_2.html

The scrolling is dead slow, in fact, it's unbearable.
Comment 79 Ivan Ičin 2005-04-10 13:32:56 PDT
(In reply to comment #78)
> What about this page:
> http://www.euronet.nl/users/frankvw/rants/microsoft/IhateMS_2.html
> 
> The scrolling is dead slow, in fact, it's unbearable.

It is very smooth for me. Maybe cause I'm using more up-to-date version:
Gecko/20050326 Firefox/1.0+
Comment 80 Aaron Kaluszka 2005-04-10 13:37:35 PDT
The problem with declaring that a testcase works or not is that this effect is
resolution-dependent.  The most recently mentioned testcase scrolls horribly for
me at 1600x1200, which I use normally, but if I resize the window to say,
800x600, it works fine.  It's not a version issue since I'm using Gecko/20050404
Firefox/1.0+
Comment 81 Osman 2005-04-10 15:14:42 PDT
(In reply to comment #78)
> What about this page:
> http://www.euronet.nl/users/frankvw/rants/microsoft/IhateMS_2.html
> 
> The scrolling is dead slow, in fact, it's unbearable.

It works pretty fine with my version of FF (Mozilla/5.0 (Windows; U; Windows NT
5.1; en-US; rv:1.7.6) Gecko/20050317 Firefox/1.0.2).

I think the worse ever case is http://www.bungie.net and by far.
Comment 82 Tim Kosse 2005-04-10 15:47:26 PDT
I have observed something interesting:
It only seems to happen for me if I have enabled ClearType font antialiasing. 
With normal or disabled font antialiasing, scrolling speed is bad to normal,
same speed as with Internet Explorer.

Tested with FF 20050410 nightly trunk under Windows XP SP2.
Comment 83 Caleb 2005-04-10 21:08:35 PDT
(In reply to comment #79)
> (In reply to comment #78)
> > What about this page:
> > http://www.euronet.nl/users/frankvw/rants/microsoft/IhateMS_2.html
> > 
> > The scrolling is dead slow, in fact, it's unbearable.
> 
> It is very smooth for me. Maybe cause I'm using more up-to-date version:
> Gecko/20050326 Firefox/1.0+

In fact, you are using an outdated version. 
I'm using:
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8b2) Gecko/20050410
Firefox/1.0+

And that www.bungie.net site scrolls just as slow as the link I posted.
Comment 84 Osman 2005-04-13 16:49:26 PDT
(In reply to comment #83)
> (In reply to comment #79)
> > (In reply to comment #78)
> > > What about this page:
> > > http://www.euronet.nl/users/frankvw/rants/microsoft/IhateMS_2.html
> > > 
> > > The scrolling is dead slow, in fact, it's unbearable.
> > 
> > It is very smooth for me. Maybe cause I'm using more up-to-date version:
> > Gecko/20050326 Firefox/1.0+
> 
> In fact, you are using an outdated version. 
> I'm using:
> Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8b2) Gecko/20050410
> Firefox/1.0+
> 
> And that www.bungie.net site scrolls just as slow as the link I posted.

I confirm. I just installed the latest trunk release from Burning Edge (
Gecko/20050405 Firefox/1.0+) and there is an HUGE improvement in the scrolling
of bungie.net.

But FF 1.0.2 was very slow. There's still a little lag in the scrolling of
pages, but it's definitively smoother now. :)

Comment 85 Eric Ellenberg 2005-04-13 19:06:54 PDT
(In reply to comment #84)
> I confirm. I just installed the latest trunk release from Burning Edge (
> Gecko/20050405 Firefox/1.0+) and there is an HUGE improvement in the scrolling
> of bungie.net.
> 
> But FF 1.0.2 was very slow. There's still a little lag in the scrolling of
> pages, but it's definitively smoother now. :)

I can vouch for this as well. The scrolling on the pages referenced (bungie.net,
euronet.nl, testcases) is very smooth now, and better than comparable to IE6.
Using Gecko/20050413 Firefox/1.0+
Comment 86 John McCormick 2005-04-13 20:57:38 PDT
Who knows why, but the last two comments are absolutely right!
Current trunk builds are displaying these much, much better than previous ones.
Bungie and the euronet.nl site both still consume 100% CPU on my machine, but
scroll (relatively) smoothly.

The original test cases all scroll beautifully, with negligible (~2%) CPU use. I
would probably have to consider this fixed :)

Oddly enough, though... I did some testing using variations of the 100-div test
case (11 divs, 22, 33, etc) and found that CPU use stays that low until about 25
fixed divs are present. After that, I get odd spikes, until at 30 I have pretty
much solid 50% or above usage. From there it rapidly hits 100%, but (as seen in
the bungie site) even with huge numbers of such elements, the 100% usage doesn't
translate to poor performance. Yay!

I wonder why CPU use is behaving so oddly... I'd have expected something more
linear. It feels like it's having to "clean up" after drawing a certain number
of frames, and as you increase the amount of drawing it has to keep track of,
that cleanup becomes less erratic and more constant. Then again, I have no idea
what I'm talking about. =P

In other news, I think the change comes from bug 205893, and after reading
through that one and bug 284978, I think I have an idea of what's going on in
the above two paragraphs, too. That's all I have time for tonight though. I
guess I would consider this resolved.
Comment 87 Eric Ellenberg 2005-04-14 10:37:26 PDT
On the other side of the coin, the latest Mac builds of Firefox and Camino (the
20050413 builds) are still horrendously slow on these sites (this is a 700MHz G4
iMac with 10.3.8), so I wouldn't resolve this bug just yet. This could be
related to issues with Quickdraw; nevertheless, I think this bug deserves more
investigation. Even sites like Gamespot (http://www.gamespot.com/) lag a bit due
to all the multimedia (graphics, flash, etc.).
Comment 88 Steve England [:stevee] 2005-04-30 10:17:07 PDT
Is position:fixed is the same as background-attachment:fixed?

I only ask because www.warp2search.net is a scrolling nightmare (make sure you
are not blocking ads if you want to observe the poor scrolling). But on removing
background-attachment : fixed; 
from body { ) definition in style.css - the page goes from scrolling nightmare
to fast & responsive.
Comment 89 John McCormick 2005-05-06 23:36:41 PDT
That would be bug 90198. Since they've shown up (and not shown up!)
independently of each other, I think they're two entirely different problems.
Comment 90 jfftck 2005-08-11 20:23:27 PDT
Created attachment 192468 [details]
Testcase that shows how the fixed elements should act

I think this should stay open until fixed elements act the same as elements
objects with a scrolling element under it. This testcase will also work in IE
and shows that normal scrolling can happen with elements that don't move.
Comment 91 jfftck 2005-08-11 20:58:55 PDT
It is like the fixed elements are on a different paint event compaired to all
other elements. I don't know anything else that would cause fixed elements to
lag behind all other elements. I also would not write-off this bug just because
faster computers don't show this bug being that bad. Right now Microsoft is
writing-off all OSs under XP, we should not do the same.
Comment 92 Robert O'Callahan (:roc) (email my personal email if necessary) 2005-08-11 21:01:10 PDT
We understand exactly what the issues are here. They're just not going to be
fixed for 1.8. 1.9 should be a lot better.
Comment 93 Milan Burda 2007-06-24 08:16:26 PDT
Hi, I've been redirected from
https://bugzilla.mozilla.org/show_bug.cgi?id=380181

to this bug regarding a problem with text scrolling on a page with fixed background, where part of the text on the right side is aligned incorrectly in the vertical direction while scrolling and after stopping the scrolling, it gets back to the correct position as seen on the screenshot:
https://bugzilla.mozilla.org/show_bug.cgi?id=380181

this can be observed in both Firefox 2.0.4 and in the latest trunk build
on this page for e.g.:
http://trainofthoughts.org/blog/2007/06/24/openpkg-apache2/

System: Windows XP SP2, Athlon XP 2600+, 1.5 GB RAM, ATI Radeon 9600 XT
Comment 94 Nicolò Chieffo 2007-11-04 05:52:43 PST
*** Bug 394005 has been marked as a duplicate of this bug. ***
Comment 95 Nicolò Chieffo 2007-11-04 06:25:58 PST
I run firefox 2.0.0.8 in ubuntu gutsy. I have both radeon and nvidia cards, and I tried opensource and proprietary drivers. This problem is very annoying and it is present in GMAIL, with the fixed element that shows the name of the following sender, when opening a long discussion.
Comment 96 fondacio 2007-11-18 09:00:23 PST
I've been following this bug for quite a long time. I used to experience it a lot, but after some hardware upgrades many of the pages linked here, as well as the testcases, scroll at an acceptable speed (current setup: WinXP Pro SP2, P4 3.0 GHz with hyperthreading, GF 6600GT, 1.5 GB RAM (although no difference with when I had 512 MB)). However, the following page is still extremely slow:

http://forum.viva.nl/forum/list_topics/1

Both IE7 and Safari hardly have problems with it. In IE7 the text jumps up and down similar to in Firefox, but not as much. Safari is really smooth. I'll try my Linux partition later but expect the same results.
Comment 97 Milan Burda 2007-11-18 11:42:53 PST
I think that someone should actually start solving this nasty problem,
as it is obvious that it is a problem...
I don't see a point in posting even more reports that oh I can see it too...
It is a bug in the code, It doesn't matter which graphics card you have, ... etc.
As Windows XP is the biggest platform (Vista is afftected) too, it's quite serious.
Comment 98 Marek Chlup 2008-02-16 04:42:43 PST
Created attachment 303709 [details]
Firefox 3b3 very very slow scrolling!!! (Firefox 2 scrolling fast)

"position: fixed;" is very importan for top menu on intranets. Browser is not good for intranets, when scrolling very very slow.
Comment 99 Dimitrios 2008-02-17 11:13:12 PST
(In reply to comment #98)
I'm afraid this testcase will be worksforme for many users. I, for, one, see the same behaviour (i.e. no problem) with FF 2.0.12 and FF 3.0b3 on Win XP, Core Duo 1.8GHz, Nvidia Geforce 7600GS (a run of the mill machine, for today's standards)
Comment 100 Peter van der Woude [:Peter6] 2008-02-17 11:24:22 PST
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9b4pre) Gecko/2008021623 Minefield/3.0b4pre ID:2008021623

all testcase WFM except the last one with the large/huge table, which isn't really this bug
Comment 101 Johannes Walther 2008-02-17 13:04:52 PST
Huh? Ok, no testcase but realworld page--what about: http://www.assoziations-blaster.de/info/Physiker.html
It's slooow in Seamonkey and FF (both recent trunk) and blazingly fast in Opera.
Comment 102 Zibi Braniecki [:gandalf][:zibi] 2008-02-17 13:16:44 PST
Huh?
Peter: how can you call it "not a bug"? The last testcase works extremely slow on Gecko trunk, and very well on Firefox 2.

If that's not a regression bug than what? "feature"?
Comment 103 Pascal Chevrel:pascalc 2008-02-17 14:12:41 PST
the one with 100 positionned elements is definitely choppy and eats 100% CPU while scrolling  (tested with Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9b4pre) Gecko/2008021404 Minefield/3.0b4pre ID:2008021404). Works perfectly on the same machine which has decent current hardaware (core 2 duo 2Ghz, 2GB ram, Nvidia 8400M card) with Firefox 2, so this is a performance regression.
Comment 104 Peter van der Woude [:Peter6] 2008-02-17 14:36:38 PST
(In reply to comment #102)
> Huh?
> Peter: how can you call it "not a bug"? The last testcase works extremely slow
> on Gecko trunk, and very well on Firefox 2.
> 
> If that's not a regression bug than what? "feature"?
> 
That testcase is a bug, but not this one.
Large tables suck when scrolled, it has nothing to do with position:fixed
Comment 105 Pascal Chevrel:pascalc 2008-02-17 14:47:18 PST
The testcase that is performing badly for me is the one with 100 positionned transparent images, not the one with 100 positionned empty so it looks like it is not due to the positionning of elements but to the alpha channel of images.
Comment 106 Zibi Braniecki [:gandalf][:zibi] 2008-02-17 14:50:26 PST
(In reply to comment #104)
> That testcase is a bug, but not this one.
> Large tables suck when scrolled, it has nothing to do with position:fixed

Let me repeat. The testcase with huge tables works very well and smooth on Fx2. It scrolls choppy on recent trunk.
I call it a regression and even if there are other issues with big tables, this one is another to put on the stack. 

Comment 107 Zibi Braniecki [:gandalf][:zibi] 2008-02-17 14:53:43 PST
I also tried to turn off position:fixed on the huge table testcase and it does help.
Comment 108 Marek Chlup 2008-02-18 02:02:58 PST
Created attachment 303996 [details]
Firefox 3b3 very very slow scrolling!!! (Firefox 2 scrolling fast)

Now, I attach new version - table is bigger and scrolling is slower. See Cpu usage and compare Firefox 3b3 with Firefox 2.

For user with ~1.5GHz CPU it is big problem! For Linux terminal server it is big problem!

"position: fixed;" is very importan for top menu on intranets. Browser is not
good for intranets, when scrolling very very slow.
Comment 109 Damian Shaw [Quan] 2008-02-28 04:03:57 PST
Shouldn't a regression like this be blocking or something? It seems like a pretty big step back.

I'm told this is A LOT worse than Firefox 2...
Comment 110 Dimitrios 2008-02-28 11:28:36 PST
Indeed FF3 shows a scrolling performance regression for very large tables but it has nothing to do with THIS bug, as other posters already noted. Please look at bug #54542 which is a 'meta' bug for all large table perfomance issues. There are decent test cases in bug #54542 that would stress even modern machines. Perhaps you may open a new bug and make bug #54542 depend on it. I'm obsoleting the last unrelated testcase.
Comment 111 Rowan 2008-03-02 20:51:36 PST
I've discovered that the height of my browser window affects the scrolling performance, the shorter the window is the smoother the scrolling, the taller the window is the slower the scrolling.

I decided to try changing the height of my Firefox window by a few pixels at a time until the performance dropped to an unacceptable level (noticeable jerkiness), this ended up being roughly 820 pixels.

This was my test page: http://www.developmentseed.org/

Specs:
Minefield 3.0b4pre (Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9b4pre) Gecko/2008030206 Minefield/3.0b4pre)
Windows XP SP2
Celeron CPU 3.06GHz
2GB of RAM
GeForce 7300 GS
Screen resolution: 1280x1024
Comment 112 IU 2008-03-30 02:53:21 PDT
Here's a site that's really bad: http://www.theloudspeakerkit.com/shop/
Comment 113 Dimitrios 2008-04-02 12:23:57 PDT
(In reply to comment #112)
> Here's a site that's really bad: http://www.theloudspeakerkit.com/shop/

The above testcase is worth examining and doesn't seem to be affected by factors unrelated to this bug.

Comment 114 thehans 2008-04-07 23:05:46 PDT
I can confirm this issue with Firefox 2.0.0.13 on Ubuntu Gutsy 7.10.  

Previous attachment: https://bugzilla.mozilla.org/attachment.cgi?id=133309 is a good simple example that exhibits this issue for me.
Comment 115 thehans 2008-04-07 23:12:02 PDT
I forgot to mention, I came across this bug after having issues mainly in Gmail, with the box showing the name of the sender in the next reply (mentioned in comment # 95), and also the "Loading..." box that shows at the top of the screen while loading a long thread.

Sorry for the double post.
Comment 116 Johan Douma 2008-04-14 03:57:32 PDT
Created attachment 315511 [details]
Demonstration: html file with big tables + css file
Comment 117 Johan Douma 2008-04-14 04:29:08 PDT
Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US; rv:1.9pre) Gecko/2008041306 Minefield/3.0pre
But it's been like this on at least the few last builds. 
I'm using Vista SP1, Core 2 Duo T7500 2.2, 2gig of ram, 8400gt. 

I just added a new attachments which demonstrates the slow down. 

The html file contains very large tables but speed is very good if there isn't a fixed div, so I don't think this is related to bug #54542. 

With only one (unlike comment #105) fixed div in the page 2008041306 Minefield/3.0pre is really slow, whereas Firefox 2 doesn't have any trouble displaying this page, not slow down at all compared to minefield. Safari and Opera are faster than Firefox 2 on this page as expected. 
Even if there is a lot of code, Minefield stops using resources as soon as the position of this div is changed. It's h2#dateTitle{ on line 424 in the css file. 
Firefox 2 is a bit slower if that div has a fixed position but it's nothing compared to the slow down occurring in minefield. 

I first thought it was the transparent png used as background but removing it didn't change anything (bug #105). 

As Rowan said in comment #111, there is a big improvement when the window is resized to a smaller size, but with a lower height, about 500px, but that's probably normal as it's a lot smaller window and faster to generate. 

I don;;t have any problem in gmail, as other poeple talk about it early but that's probably not related. Probably Bug #424915.
I don't know about minefield on mac, I'll have a look tomorrow.


Comment 118 kp.watzlawek 2008-05-22 09:57:21 PDT
I realized this bug in Firefox 3 RC1. The scrolling speed of Firfox 3 RC1 is very catastrophic if you use the "Fixed" attribute in a stylesheet after a big background image (1680x1050 Pixels).

I include 3 examples, which show the bug!

http://abiads08.ab.funpic.de/test123/index.html <-- attribut: Fixed, big background image --> slow

http://abiads08.ab.funpic.de/test123/index2.html <-- attribut: Fixed, samll background image  --> fast

http://abiads08.ab.funpic.de/test123/index3.html <-- only big background image --> fast

<style type="text/css">

 body { background:#09aeff url(bg.jpg) fixed center; }

</style>

As you can see the problem appears only if you are using big background images with fixed attribute in CSS.

Comment 119 Eugene R. Miller 2008-05-23 02:01:31 PDT
For the record, I've had this problem in Firefox 2, 3b5 and 3rc1

In firefox 2.0.0.* if there is a fixed image like blog.the-erm.com has.  Scrolling barely takes a hit, however in 3b5 scrolling speed is slowed down dramatically, and it's jerky  in 3rc1 it gets much much worse. I couldn't handle using it for more than 5 min before I realized I better get used to 2. because I can't upgrade to 3 with this kind of performance hit.  It's a pitty too, because I improvements to the browser bar.  The net is my income, and one of the pages I have that makes me the $$ has such a div, If I started using 3, I'd loose hours out of my year waiting for the screen to update, and considering I don't get paid until the job is done.  I'd be loosing time & money if I used 3.

I'm running kubuntu linux 8.04 in (kde 3.5.9).  I haven't tested it in gnome.

But a fixed div with bottom:0; right:0; *really* makes it slow in 3rc1 so much so that I would consider running firefox3 to be a downgrade over firefox2. Some pages have this problem in firefox 2 because people are being stupid and have a big fixed background image on their page like myspace user always do.

Comment 120 Johan Douma 2008-05-23 02:14:45 PDT
True, this is defenitly a regression, there is a  huge difference between 2 and 3RC I posted here 6 weeks ago and nothing has happenned since. Worse Firefox is now RC... I hope this is going to be fixed. If not I'll be using Safari for a part of my work as one of the tools I used has a lot of tables+cells and fixed elements.
Please, I really like Firefox, don't leave this unfixed.
Comment 121 Unknown W. Brackets 2008-05-23 09:42:22 PDT
I really hate "me too" comments, and don't mean to make one here... but I have to say I cannot imagine Firefox 3 going out with this bug.

A lot of sites, including MySpace pages as some have noted, blogs, etc. are affected by this bug.  While it's true some may change things to workaround this bug - that's really bad from an evangelism perspective.

I know that it's already RC1, and I'm figuring honestly there's no chance for this bug.  Worse, I'd try to help and make a patch or at least troubleshoot the code, but I really don't have time in the next few weeks to do so - just to complain.  Still, I wish this was getting more attention - even if it has to be for 3.1... then I could tell people of the light at the end of the tunnel.

Thanks,
-[Unknown]
Comment 122 Gérard Talbot 2008-05-23 15:48:20 PDT
To those who comment(ed) and/or complain(ed) about this bug:

1- How many of you have smooth scrolling on?

2- "dead slow", "horrible", "unbearable", etc.. are very subjective adjectives which do not give any kind of accurate measurement, objective measurement, quantifiable data, comparable data like a performance profile comparison. 0.3sec could be deadly slow to you while 0.4sec could be just fast enough to person_B. We have no idea here. How big is the gap between horribly slow and fast enough in milliseconds? We have no clue, no idea, not even an hint. And we have to compare (and to assess) all these measurements regarding respective hardware, configuration, os, settings, etc... involved.

3- How long is a long table or a very long table? "very long" is still vague, not quantifiable, non comparable, non-specific, not really useful ... and I'm not even mentioning nested tables, deeply nested tables and over-excessively formated tables for layout purpose here..
"scrolling performance regression for very large tables but it has nothing to do with THIS bug". Dimitrios, comment #110

4- How many of you are mentioning webpages which have hundreds of validation markup errors, CSS errors, regarding webpages which can not in any way constitute a reduced testcase highlighting the issue in this bug?

5- How many of you are mentioning webpages that have lots of images, which are Flash-intensive, Flash-dependent, with a very large and deep DOM tree of nodes, with divitis and classitis, with thousands of javascript lines of code spread into several script files and functions, abusing setTimeout and setInterval, with generated content (like ads rotating, iframe refreshed), in over-constrained layout, over-excessively defined constraining stylesheets for pixel-perfect layout, etc.?

6- How many of you are mentioning webpages which would be considered - anyway and regardless - CPU-demanding, RAM-demanding, video-memory-demanding and user-system-resources demanding according to today's standards? How many of those webpages are already pushing the limits a bit far to begin with?

7- "'position: fixed;' is very importan for top menu on intranets": Do intranet webpage require 100 fixed elements?

8- How many of you are referring to characteristics which should be reported in other bugs (bug 90198, bug 64401, bug 202718, bug 54542, etc...) and not in this bug?

9- How many of you have read
What is a Simplified Test Case, and How Do I Make One?
http://www.mozilla.org/newlayout/bugathon.html#testcase

10- How many of you have read 
How to Really, Really Help Developers on Bugs -- Minimal Testcases
http://wiki.mozilla.org/MozillaQualityAssurance:Triage#How_to_Really.2C_Really_Help_Developers_on_Bugs_--_Minimal_Testcases

11- How many background images (tiled) constitute the fixed background regarding the mentioned webpages? You do understand that one big image in the background is quite different from having 1px by 1px image repeated+tiled all over the canvas... Anyway, why such issue is mentioned in this bug and not instead bug 90198 .. if that is needed?

12- How many of you have actually read the Bug writing guidelines?
http://developer.mozilla.org/en/docs/Bug_writing_guidelines

13- How many of you have actually read the bugzilla etiquette?
https://bugzilla.mozilla.org/page.cgi?id=etiquette.html

14- http://firefox.bric.de/index.php mentioned in comment #39 is 403 Forbidden; <a href="http://www.n3t.nl/mozbug/">minimal tescase</a> mentioned in comment #74 is redirected; etc.

15- http://www.theloudspeakerkit.com/shop/ has been mentioned in comment #112: a closer examination of that page reveals flash-dependency, lots of mouseover script dependency, general bloated markup code, 4 imported stylesheets (with one declared twice), over 700 lines of CSS code and not even one, not one, position: fixed element.

16- http://abiads08.ab.funpic.de/test123/index.html mentioned in comment #118 is not at all a recommendable webpage (general bloated code, lots of errors, ads-embedded) for this bug. In fact, after carefully checking, there is no position: fixed elements found anywhere. background-attachment: fixed may be about bug 90198 like others have said.

Once a bug has been confirmed and is clearly defined, well understood, there is very little one can say that will actually help besides 
a) submitting a patch or 
b) funding/subsiding a fix by developers.

When I try attachment 139911 [details] with today's trunk build, I can not notice any slow scrolling issues worth mentioning. Same thing with the provided URL. Same thing with the so-called "dead slow", "unbearable" webpage
http://www.vanwensveen.nl/rants/microsoft/IhateMS_2.html mentioned in comment #78. And I have a modest P3 667Mhz, 384MB RAM on Windows XP SP3. And this bug is filed for trunk, not to the 1.8 or 1.9.0 branch. And even in 1.8 and 1.9.0 branches, I notice nothing dramatic or obviously slow.

To me, this bug should be resolved as WFM and shouldn't be reopened without excellent reasons to and with many conditions met.

Regards, Gérard
Comment 123 DJiK 2008-05-23 16:13:33 PDT
> 1- How many of you have smooth scrolling on?

Without, it's a little better, but 100% CPU anyway.

I think this bug https://bugzilla.mozilla.org/show_bug.cgi?id=400230 is a duplicate. I posted a few examples of lagging sites in it.
Comment 124 Unknown W. Brackets 2008-05-23 16:22:29 PDT
(In reply to comment #122)
> To those who comment(ed) and/or complain(ed) about this bug:
> 
> 1- How many of you have smooth scrolling on?
> 
> 2- "dead slow", "horrible", "unbearable", etc.. are very subjective adjectives
> which do not give any kind of accurate measurement, objective measurement,
> quantifiable data, comparable data like a performance profile comparison.
> 0.3sec could be deadly slow to you while 0.4sec could be just fast enough to
> person_B. We have no idea here. How big is the gap between horribly slow and
> fast enough in milliseconds? We have no clue, no idea, not even an hint. And we
> have to compare (and to assess) all these measurements regarding respective
> hardware, configuration, os, settings, etc... involved.

Your comments are very long and I cannot answer all of the points, but I can answer these.

Let's use for a test case "http://www.tuaw.com/".  The following builds of Minefield and Bon Echo will be used for comparison:

Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9pre) Gecko/2008052308 Minefield/3.0pre
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.15pre) Gecko/20080520 BonEcho/2.0.0.15pre

1. general.smoothScroll greatly aggrevates this bug.  Since there is UI to turn this on, let's test with it enabled in both Bon Echo and Minefield, please. (note that the problem occurs with it off.)

2. Let us measure how long it takes to scroll to the bottom of this same page in Minefield and Bon Echo.  I'm using a not-as-modest AMD 64 X2 3800+ w/2.0 gig of ram, a GeForce 7600 GT at 1280x1024, and XP SP2.  We will preform this test by consistently scrolling the mousewheel.  I'm timing using my iPhone manually.

Minefield (smoothScroll OFF): 00:08.2
Minefield (smoothScroll ON): 00:14.0
BonEcho (smoothScroll OFF): 00:07.1
BonEcho (smoothScroll ON): 00:07.2

However, Minefield in both cases gets a lot of shearing (a very distinct and definable phenonemon), whereas BonEcho is fine.

Now, this is not a reduced testcase as you say.  Good point.  Let's make it one.  Go ahead and install Firebug in both browsers.  For best results, use the same version of Firebug (1.1 or 1.2).

Open Firebug on the website, click "HTML", and then on "<body>".  On the right, select the "Style" tab.  Look for "background:", and click on it.

Change the value from:
#477CBD url(http://www.blogsmithmedia.com/www.tuaw.com/media/tuaw-bg.jpg) no-repeat fixed 50% 0pt

To:
#477CBD url(http://www.blogsmithmedia.com/www.tuaw.com/media/tuaw-bg.jpg) no-repeat scroll 50% 0pt

This removes the "fixed" scrolling being discussed here.  Now, run the above tests again.  You will notice a difference.

I imagine this may have to do with possible any of the following factors:
A. Screen resolution/browser size.
B. Length of page and number of elements overlaying background (most likely just height of elements.)
C. Size of background image (width/height.)
D. Positioning of the background image.

This is clearly a regression from Bon Echo (which had no problems here.)

-[Unknown]
Comment 125 Gérard Talbot 2008-05-23 20:31:17 PDT
@Unknown, 

I commend your efforts to bring more formal steps to reproduce and more objective data/measurements (including possibly performance profiling) into this bug...

>  Look for "background:", and click on it.
> 
> Change the value from:
> #477CBD url(http://www.blogsmithmedia.com/www.tuaw.com/media/tuaw-bg.jpg)
> no-repeat fixed 50% 0pt
> 
> To:
> #477CBD url(http://www.blogsmithmedia.com/www.tuaw.com/media/tuaw-bg.jpg)
> no-repeat scroll 50% 0pt
> 
> This removes the "fixed" scrolling being discussed here.

... but all this is about background-position: fixed which is bug 90198, not this bug 201307. This 201307 bug shouldn't be far from being fixed if bug 203439 has been fixed. Again, I still think this bug should be resolved as WFM... unless someone can bring something real, concrete, reproducible, good testcase, etc... Who here experienced "slow scrolling" with attachment 139911 [details] and with provided URL (http://www.w3.org/Style/Examples/007/scrollbars.html)?

Your post also identified how you scrolled (which is very good from a reproducibility perspective): you roll the mousewheel. You see, it could have been [PgDn], [PgUp], dragging scrollbar thumb up|down, clicking the scrollbar arrows or up|down key arrows...

------

@madjik

If smooth scrolling is ON, then it should be resolved as a DUPLICATE of
bug 202718 (Windows), bug 424308 (Mac), bug 409456 (Linux)
Comment 126 Gérard Talbot 2008-05-23 20:41:11 PDT
> preform this test
> by consistently scrolling the mousewheel. 
> 
> Minefield (smoothScroll OFF): 00:08.2
> Minefield (smoothScroll ON): 00:14.0

That has to be bug 202718, not *this* bug.
Comment 127 Unknown W. Brackets 2008-05-23 20:48:43 PDT
(In reply to comment #125)
> ... but all this is about background-position: fixed which is bug 90198, not
> this bug 201307. This 201307 bug shouldn't be far from being fixed if bug
> 203439 has been fixed. Again, I still think this bug should be resolved as
> WFM... unless someone can bring something real, concrete, reproducible, good
> testcase, etc... Who here experienced "slow scrolling" with attachment 139911 [details]
> and with provided URL (http://www.w3.org/Style/Examples/007/scrollbars.html)?

Ah, I confused this with that one (actually I thought they were the same, but now that I delve into my memory, I remember that there were two bugs after all.)  Before I didn't care about that other one, because I thought it was reasonably fast.... then I forgot they were different bugs.

Sorry for the bugspam.  IMHO, as a developer, I don't think this needs to be fixed at all for 3.0 or anything.  Virtually no sites use position: fixed, it's not (or wasn't once) well supported across browsers anyway iirc.

That said, bug 90198 really is about a more general problem of it "being slow".  Probably I'm looking for a more specific bug for this actual regression.

Sorry for the bugspam.

As for that attachment, it scrolls identically for me in Bon Echo and Minefield, and what's more, very quickly and without shearing.  Again, I totally agree this bug is probably not a huge issue (and from the comments which I just looked over again, seems to find a lot of people confusing it with backgrounds.)

(In reply to comment #126)
> > preform this test
> > by consistently scrolling the mousewheel. 
> > 
> > Minefield (smoothScroll OFF): 00:08.2
> > Minefield (smoothScroll ON): 00:14.0
> 
> That has to be bug 202718, not *this* bug.
> 

Not really.  I don't care about smooth scrolling.  It's easier to reproduce using smooth scrolling (likely because of that bug) but I'm talking about the *recent* change in speed of scrolling with fixed backgrounds (compared to Bon Echo) whether smooth scrolling is enabled or not.

That bug is about both versions (and even older too), and I see shearing on the page it references even with my hardware and Bon Echo.

-[Unknown]
Comment 128 Johan Douma 2008-05-23 23:36:43 PDT
Firefox 3 2008052304

(In reply to comment #122)

> 1- How many of you have smooth scrolling on?
Nope it's off.

> 2- "dead slow", "horrible", "unbearable", etc.. are very subjective adjectives
> which do not give any kind of accurate measurement
1 sec between redraws maybe

> 3- How long is a long table or a very long table? "very long" is still vague
6 tables of 62 columns, 15 lines each, no backrgrounds on the cells. 

> 7- "'position: fixed;' is very important for top menu on intranets"
2 fixed divs

> 4- How many of you are mentioning pages which have hundreds of validation errors
> 5- lots of images, Flash-intensive, Flash-dependent, with a very large and deep 
> DOM tree of nodes with thousands of javascript lines of code spread
> into several script files and functions, abusing setTimeout and setInterval,
> with generated content (like ads rotating, iframe refreshed), in
> over-constrained layout, over-excessively defined constraining stylesheets for
> pixel-perfect layout, etc.?
> 6- How many of you are mentioning webpages which would be considered - anyway
> and regardless - CPU-demanding, RAM-demanding, video-memory-demanding and
> user-system-resources demanding according to today's standards? How many of
> those webpages are already pushing the limits a bit far to begin with? 

Yes that's the case.

Maybe it should be slow then... regarding the mess in the code. After reading comment #122 this slow down could definitly be normal and justified. And a few people have probably been convinced that it's not a firefox problem. 

The code is a mess and is pretty heavy, there's a fixed div with a png background, and there a png background. It's slow. Without the images it's better but still slow. 
So I actually have 2 'bugs' here at the same time. But both of them have a big impact on performance.

I'm posting this because Firefox 2 handles it perfectly fine.  

Like W. Brackets did, comment #124, rolling the scroll wheel as fast as possible, the time it took to scroll from top to bottom of the page, retried, 3 or 4 times if any difference:

Smoothscroll on 
FF 2 about 5, 6 seconds, slightly slower than whithout smoothscrolling. 
FF 3 2008052304 took an astonishing 48 seconds the first time and 50 seconds the second time I tested it. Where 20 seconds are spent on the last 200px of the page. 8 times slower?
We knew already that smoothscrolling did that, but I didn't really expect it to be this bad. Redrawn once per second as well, not worse then with smoothscroll off, but the distance scrolled at each redraw is a lot smaller. 

Smoothscroll off:
Firefox/2.0.0.11 20071127: between 3 and 5 secondes, redrawing maybe 4 or 5 times a second. 
Firefox 3 2008052304 after trying several times: between 13 and 15sec to scroll from the top to the bottom, with about 1 redraw per second. About 3 times slower...

But I don't really see shearing, a slight bit, but far less than some other websites on internet somethimes.

I'm not using smoothscrolling anyway, I don't use it. 

This has been tested on a G5 1.8ghz 2gig ram, some nvidia card... I'm at work at the moment. But on Vista SP1 core 2 duo 7500, 2gig ram, 8400gt, the result is the same, it's faster but the differences between firefox 2 and 3 are still there. 

The website where I get this is on the intranet. There is a lot of private info on there, and the last attachment I posted has been stripped a bit too much too really see what happens on the intranet. The difference of speed between firefox 2 and 3 is not a visible as in the real case with the images but it's still there.
I will try to upload a new archive containing the images/html/css files, stripped from the private information.
I'll keep in touch.
Comment 129 Gérard Talbot 2008-05-24 09:58:22 PDT
> Yes that's the case.
> 
> Maybe it should be slow then... regarding the mess in the code. After reading
> comment #122 this slow down could definitly be normal and justified. And a few
> people have probably been convinced that it's not a firefox problem. 
> 
> The code is a mess and is pretty heavy, there's a fixed div with a png
> background, and there a png background. It's slow. Without the images it's
> better but still slow. 
> So I actually have 2 'bugs' here at the same time. 

Or maybe the position: fixed bug has been fixed.

> But both of them have a big
> impact on performance.

Correct and appropriate QA bug management indicate that we shouldn't confirm a bug unless a set of conditions are met, a good, clear testcase, thorough search for duplicate has been done, etc.

> I'm posting this because Firefox 2 handles it perfectly fine.  
> 
> Like W. Brackets did, comment #124, rolling the scroll wheel as fast as
> possible, the time it took to scroll from top to bottom of the page, retried, 3
> or 4 times if any difference:
> 
> Smoothscroll on 
> FF 2 about 5, 6 seconds, slightly slower than whithout smoothscrolling. 
> FF 3 2008052304 took an astonishing 48 seconds the first time and 50 seconds
> the second time I tested it. Where 20 seconds are spent on the last 200px of
> the page. 8 times slower?
> We knew already that smoothscrolling did that, but I didn't really expect it to
> be this bad. Redrawn once per second as well, not worse then with smoothscroll
> off, but the distance scrolled at each redraw is a lot smaller. 
> 
> Smoothscroll off:
> Firefox/2.0.0.11 20071127: between 3 and 5 secondes, redrawing maybe 4 or 5
> times a second. 
> Firefox 3 2008052304 after trying several times: between 13 and 15sec to scroll

Then that is bug 202718, not *this* bug. Discussion, data, comparison regarding smoothscroll ON or OFF should not be in this bug.

> The website where I get this is on the intranet.

Realistically speaking, there is nothing to be done without being able to examine, investigate, test, performance-profile a webpage. We still would need a reduced testcase focusing and targeting (and highlighting) well the performance + behavior considered as incapacitatingly slow.

> I will try to upload a new archive containing the images/html/css files,
> stripped from the private information.

Please consult

What is a Simplified Test Case, and How Do I Make One?
http://www.mozilla.org/newlayout/bugathon.html#testcase

How many of you have read 
How to Really, Really Help Developers on Bugs -- Minimal Testcases
http://wiki.mozilla.org/MozillaQualityAssurance:Triage#How_to_Really.2C_Really_Help_Developers_on_Bugs_--_Minimal_Testcases

I believe that attachment 139911 [details] and this bug's URL 
http://www.w3.org/Style/Examples/007/scrollbars.html
were adequate webpage and testcase for this bug. If no one experiences significant (measurable) loss of performance in those webpages with a trunk build, then this bug should be resolved as WFM.
Comment 130 Johan Douma 2008-05-24 21:10:44 PDT
@Gérard Talbot No offense but it looks to me as if you're trying to convince everyone that there isn't any bug. I do think there's is something with this position:fixed

I wasn't comparing smoothscroll.

Here are the results again, with smoothscroll off:
FF2: between 3 and 5 seconds, redrawing maybe 4 or 5 times a second 
FF3: between 13 and 15 seconds, redraw once a second
that's 4 to 5 times slower.



I've posted an attachment already a few weeks ago, cleaned up from all the images only but not css. I know I should have created a simple file with a fixed div and some text... I did read the 'howto' file a bug and do tests, etc...

But in my case it's a bit complex. So please bear with me and maybe advise me on how to proceed with this case.

In this case:  
I have a png in the background, and a png in the fixed div, and a hole lot of tables, lot of stuff styled... All together it's slow. See results above.
If I get rid of the fixed div. It's back to normal, it's not slowed down. This tells me I'm in the correct bug, and I'm not posting in the wrong place. 
BUT with the fixed div:
If I get rid of the png backgrounds and keep the fixed div, it's still slow but a lot better. And when I get rid of all the css styles, then it's back to a normal speed. Speed difference slightly visible. 
 
I know it really sounds like it's something else in the code that slows it down, but I've spent a few hours removing rules one by one to see if there was a performance impact. And it became better, gradually; I couldn't see any difference each time I removed a rule. In the end there wasn't much an impact between 'not fixed' and 'fixed'.

Concludion:
- Clean of images and css, difference slightly visible.
- Alltogether, css, images, etc... Big difference between the version that has the fixed div and the one that hasn't. 


Now I'm only speculating on how this is possible... 

in FF2, a fixed div might have a 50% performance impact... So between the version that may take let's say, 100ms, it will take 150ms if there is a fixed div. 

in FF3, there might be a 500% performance impact. 
So on the simple test case like attachment #139911 [details] where it takes 10ms to draw without fixed div, it would take 50ms, with a fixed div. 50ms is not slow. The few attachment indeed do not have any significant loss of performance.
But if the page takes 100 seconds to be drawn without fixed div because it's damn complex, it would take 500ms to redraw with fixed div. 

So no I will not post a testcase like attachment #139911 [details], because it doesn't represent what I get. But i don't really have any other ideas to post a test case whitout all the css and images. Anybody has any ideas on how to create a test case for this?
Comment 131 Gérard Talbot 2008-05-26 13:20:02 PDT
> it looks to me as if you're trying to convince
> everyone that there isn't any bug. 

I do not see a bug. I can not reproduce the problem when using a trunk build on windows. I can not reproduce the problem when trying all of the mentioned URLs so far, including this bug's provided URL http://www.w3.org/Style/Examples/007/scrollbars.html
and attachment #139911 [details] . Now, if the bug is still happening on the trunk, then provide a testcase relevant and relative to this bug. Do you understand?

I am trying to convince you that several of the so-called URLs, testcases included in this bug were
- 404 not found
- redirected to nowhere
- abusing or depending on Flash
- abusing or depending on javascript
- have huge amount of coding errors, are examples of over-excessive formating, over-excessive coding, declaring, over-constrained layout,
- etc..

and that none of this serve the purpose of demontrating or reproducing or isolating a bug or faulty behavior or weak performance. If this bug still occurs, then at least a large minority of us should notice, measure something significant when trying attachment attachment #139911 [details] or this bug's provided URL.

> I do think there's is something with this
> position:fixed

Fine! Then proceed accordingly with

What is a Simplified Test Case, and How Do I Make One?
http://www.mozilla.org/newlayout/bugathon.html#testcase

How to Really, Really Help Developers on Bugs -- Minimal Testcases
http://wiki.mozilla.org/MozillaQualityAssurance:Triage#How_to_Really.2C_Really_Help_Developers_on_Bugs_--_Minimal_Testcases

There are such things as the capability to reproduce a bug under controlled conditions, where we can compare data, examine testcases, use and compare (before fix and after fix) performance profiles, etc... Otherwise we shouldn't confirm a bug.

> I wasn't comparing smoothscroll.

Why do people in this bug keep mentioning smooth scroll then? Why can't you provide smooth scroll related data to respective bugs like bug 202718 (Windows), bug 424308 (Mac), bug 409456 (Linux)?

> Here are the results again, with smoothscroll off:
> FF2: between 3 and 5 seconds, redrawing maybe 4 or 5 times a second 
> FF3: between 13 and 15 seconds, redraw once a second
> that's 4 to 5 times slower.

Which test case are you referring to? What's your overall system configuration for getting those data? I can not reproduce anything close to your data with this bug's provided URL http://www.w3.org/Style/Examples/007/scrollbars.html
and attachment #139911 [details].

> I've posted an attachment already a few weeks ago, cleaned up from all the
> images only but not css. I know I should have created a simple file with a
> fixed div and some text... I did read the 'howto' file a bug and do tests,
> etc...
> 
> But in my case it's a bit complex. 


It is **NOT** just a bit complex. It's an 85 Kilo-byte HTML file (7598 lines of code, 86193 bytes!) with several linked (external and imported) stylesheets and several linked external javascript files that we can not see or examine with your RAR compressed file because your very long HTML file uses relative addressing, not absolute addressing. And I'm not even mentioning inline style, inline javascript code, invalid markup code, for populating dynamically "n" tables and table cells, etc..:

<link href="screen.css" rel="stylesheet" type="text/css" />
<style type="text/css" >
@import url("inc/print.css") print;
</style>
<script src="combine.php?type=javascript&files=dojo.js,scripting.js" type="text/javascript"></script>
<title>Planning - last mod: Sun, 13 Apr 2008 12:18:39 GMT</title></head>
<body>
<script type="text/javascript" src="inc/calendar/calendar.js"></script>
<script type="text/javascript" src="inc/calendar/lang/calendar-fr.js"></script>
<script type="text/javascript" src="inc/calendar/calendar-setup.js"></script>
<style type="text/css" >
@import url("inc/calendar/calendar-blue2.css") screen;
</style>
<script type="text/javascript">
    function client_info(id_client) {
      dojo.xhrGet( { 
        url: "####="+id_client, 
        handleAs: "text",
        timeout: 5000,
        load: function(response, ioArgs) {
          dojo.byId("infoDiv"+id_client).innerHTML = response;
          return response;
        },
        error: function(response, ioArgs) {
          console.error("HTTP status code: ", ioArgs.xhr.status);
          return response;
          }
        });
      }
  </script>

    <script type="text/javascript">
  Calendar.setup(
    {
      inputField  : "startInputTime",         // ID of the input field
      ifFormat    : "%d-%m-%Y",    // the date format
      button      : "startInputTime"       // ID of the button
    }
  );
  Calendar.setup(
    {
      inputField  : "stopInputTime",         // ID of the input field
      ifFormat    : "%d-%m-%Y",    // the date format
      button      : "stopInputTime"       // ID of the button
    }
  );
  Calendar.setup(
    {
      inputField  : "startEmptyInputTime",         // ID of the input field
      ifFormat    : "%d-%m-%Y",    // the date format
      button      : "startEmptyInputTime"       // ID of the button
    }
  );
  Calendar.setup(
    {
      inputField  : "stopEmptyInputTime",         // ID of the input field
      ifFormat    : "%d-%m-%Y",    // the date format
      button      : "stopEmptyInputTime"       // ID of the button
    }
  );
</script>


> So please bear with me and maybe advise me
> on how to proceed with this case.

I have already:

What is a Simplified Test Case, and How Do I Make One?
http://www.mozilla.org/newlayout/bugathon.html#testcase

How to Really, Really Help Developers on Bugs -- Minimal Testcases
http://wiki.mozilla.org/MozillaQualityAssurance:Triage#How_to_Really.2C_Really_Help_Developers_on_Bugs_--_Minimal_Testcases 

> In this case:  
> I have a png in the background, and a png in the fixed div, and a hole lot of
> tables, lot of stuff styled... All together it's slow. See results above.
> If I get rid of the fixed div. It's back to normal, it's not slowed down. This
> tells me I'm in the correct bug, and I'm not posting in the wrong place. 
> BUT with the fixed div:
> If I get rid of the png backgrounds and keep the fixed div, it's still slow but
> a lot better. And when I get rid of all the css styles, then it's back to a
> normal speed. Speed difference slightly visible. 

> Concludion:
> - Clean of images and css, difference slightly visible.

Those images are relatively linked. So we can not examine or test them. Non-optimized images is not rare on the web. Linked external stylesheets with relative links, not absolute links; same thing with javascript. Your testcase is for sure not a good testcase it does not - I REPEAT - does NOT allow us to examine what you have in those external files linked into your 85KB HTML webpage.

> - Alltogether, css, images, etc... Big difference between the version that has
> the fixed div and the one that hasn't. 

This bug is about positioned fixed elements. This bug is not about images with background-attachment: fixed.

This bug is supposed to be occuring even with javascript disabled. This bug is about positioned fixed elements. This bug is not about populating dozens of tables and hundreds of table cells dynamically.

> Now I'm only speculating on how this is possible... 

The difference between a good testcase and a bad one is that a good testcase reduces questions, it removes doubts, it reduces/eliminates speculation, it's more targeted, it clarifies the target, it isolates the real issue, it's useful to verify that the bug has been fixed, etc.
Your attachment 315511 [details] does none of that. First off, we can not even examine the images, the imported and external linked stylesheets, the javascript external files, etc.. because the linkage you use in that attachment 315511 [details] is relative, not absolute. On top of that, once uncompressed, the attachment 315511 [details] becomes a 85KB file with 7598 lines of code!!

> So no I will not post a testcase like attachment #139911 [details], because it doesn't
> represent what I get. 

attachment #139911 [details] represents accurately and reliably what this bug's summary is about. If you notice/measure no significant loss of performance or speed or time duration on the trunk, then I say this bug has been FIXED already (bug 203439 has been FIXED, you know) and should be resolved as WORKSFORME. Do you understand?
Comment 132 Unknown W. Brackets 2008-05-26 15:15:02 PDT
Created attachment 322577 [details]
Simple test case with plenty of fixed divs (requires js.)

Here's an example that shows plenty of fixed divs.

Doesn't appear to be affected by using an image as a background or not.  Greatly affected by smooth scrolling, but that's not this bug.

For me, performance is similar in Minefield and Bon Echo.
Comment 133 Greg Campbell 2008-05-27 16:31:50 PDT
With this testcase, I detect a small amount of slowness compared to scrolling this bug report. I have a feeling it's dependent on system specs, but with my approx. 2-year old hardware it's barely detectable. With a 600 MHz PIII, it might be a different story.

One thing I notice is that the scrolling decelerates when it gets to the last 5 or so lines at the top or bottom of the page. This does not happen on a page without the fixed elements.

I see very similar performance with Fx2 and Fx3 RC.
Comment 134 Marek Chlup 2008-05-27 23:23:25 PDT
FF2: Mozilla/5.0 (X11; U; Linux i686; cs-CZ; rv:1.8.1.12) Gecko/20080129 Iceweasel/2.0.0.12 (Debian-2.0.0.12-1)
FF3RC1: Mozilla/5.0 (X11; U; Linux i686; cs; rv:1.9) Gecko/2008051202 Firefox/3.0

Processor: AMD Sempron(tm) Processor 2600+
RAM: ~440 MB
OS: Debian with 2.6.25-1-686 kernel
Resolution: 1280x1024
general.smoothScroll: false

Scroll by arrow down key on keyboard.

attachment #139911 [details]  - only "box 1" is "lock (fixed)"
------------------
1) FF2:
   2s (scroll is fine and continuous; usage CPU: 57%)
2) FF3RC1:
   5s (scroll is brokenly; usage CPU: 100%)

attachment #303996 [details]
------------------
1) FF2:
   27s (scroll is fine and continuous; usage CPU: 57%)
2) FF3RC1:
   131s (scroll is brokenly; usage CPU: 100%)
Comment 135 Jakub 'Livio' Rusinek 2008-06-04 05:14:14 PDT
with smooth scrolling that's even bigger massacre :s .
Comment 136 Dimitrios 2008-06-04 12:15:05 PDT
Comment on attachment 315511 [details]
Demonstration: html file with big tables + css file

After properly reducing that testcase, I noticed that the only important factor in it is border-right:solid and border-bottom:solid properties of the cells. Therefore, it is irrelevant to this bug
Comment 137 Robin Knapp 2008-06-22 11:07:20 PDT
I found this bug report when searching for problems on slow scrolling and fixed elements.

http://planetsuse.org/ produces *very* annoying slow scrolling effects; the site is barely usable (it gets even worse when zoomed in)

Hope this helps...

specs:
Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.9) Gecko/2008052906 Firefox/3.0
Running Ati radeon mobility X600
Comment 138 Jakub 'Livio' Rusinek 2008-06-22 11:10:39 PDT
Same problem, but I have nVidia GeForce 6200.

Both with nv and nvidia (closed-source nVidia provided driver) have the problem.
Comment 139 DJiK 2008-06-22 11:26:24 PDT
It's correct on http://planetsuse.org/

Try this one: http://www.boobalechat.com/archive-06-2008.html
For me, it's the worst.


After seeing this, or http://actu.c4.fr/ or http://www.howtocreate.co.uk/fixedPosition.html (even fixed but smooth in IE6), I start moving on Opera... :-/

Comment 140 Dimitrios 2008-06-23 14:22:56 PDT
(In reply to comment #139)
> Try this one: http://www.boobalechat.com/archive-06-2008.html
> For me, it's the worst.
Again, please read technical info already posted here before posting an irrelevant testcase. Especially read comment #125. What you see in your case is NOT this bug. It's bug #90198. (I don't notice performance problems with the rest of the links you mentioned so I won't comment on them).
Comment 141 DJiK 2008-06-24 11:14:16 PDT
You're right, sorry. I follow them both.
Don't you think these 2 bugs have the same origin? Fixed = lag...

And even those with smooth scrolling listed on comment #125. Fixed = lag.
Comment 142 kataho.mail 2008-06-26 07:14:51 PDT
Created attachment 326909 [details]
a bit of position:fixed element and a bunch of resized images
Comment 143 kataho.mail 2008-06-26 07:19:24 PDT
A combo of any position:fixed elements and a bunch of resized images remarkably decreases frame rate. Check out attachment #326909 [details] with Firefox3. Turn smooth scroll on and scroll up and down and see difference on responce between on upper side and on lower side. Upper side is filled with resized images and lower side is filled with raw ones. Our fixed element is only one black dot on upper right. 

You may want to say that this is caused by resized images but a position:fixed element. If you can not be sure, comment this little dot out and see the performance turns to all just fine.
Comment 144 Tomasz Sałaciński 2008-07-03 12:59:56 PDT
Yes, I can agree. It's not because of large images, because they are handled properly. Mozilla works lightning fast even with very complex websites, but only if fixed elements are removed.

It's something that has to be fixed, as well as resizing pages (when you resize page once, after that it works properly, but it's very slow if you start resizing for the first time).

I think this can solve all performance issues with Firefox.
Comment 145 Jakub 'Livio' Rusinek 2008-07-03 13:04:07 PDT
> I think this can solve all performance issues with Firefox.

Nooo :> .

Add background with bg-attachment:fixed and transparent image on top.

It will be slow.

For example this is slow: http://blog.ninaque.com/
Comment 146 Tomasz Sałaciński 2008-07-03 13:09:53 PDT
Yes, as I said, this background is fixed. Removing it makes Firefox working fast again. That self-transparent logo on top doesn't seem to slow down the performance for me.
Comment 147 Eugene R. Miller 2008-07-06 06:42:08 PDT
This is a lousy fix, but it works.

When you move the mouse wheel, it hides the fixed div, so you can scroll, and then after a second of no movement, it'll show it again.  I don't use the up/down arrows to scroll the page, so I didn't include an "onkeydown" window event, but it wouldn't be that hard to implement.





<style>
  #fixedDivId {
    position:fixed;
    right:0px;
    bottom:0px;
    border: 1px solid #000;
    background: #FFF;
  }

</style>


<div id="fixedDivId">I'm fixed.</div>

<script type="text/javascript"><!--

var hideTimer = false;
window.addEventListener('DOMMouseScroll', hideFixedDiv, false);

function hideFixedDiv(e){
	document.getElementById('fixedDivId').style.display = 'none';
	if (hideTimer) {
		clearTimeout ( hideTimer );
	}
	hideTimer = window.setTimeout("document.getElementById('fixedDivId').style.display = ''; hideTimer = false;", 1000);
}

//-->
</script>

---- Same thing only in jquery, and using a class.

<style>
  ,fixed {
    position:fixed;
    right:0px;
    bottom:0px;
    border: 1px solid #000;
    background: #FFF;
  }

</style>

<div class="fixed">I'm fixed.</div>

<script type="text/javascript"><!--

var hideTimer = false;
window.addEventListener('DOMMouseScroll', hideFixedClasses, false);

function hideFixedClasses(e){
	$('.fixed').css('display','none');	
	if (hideTimer) {
		clearTimeout ( hideTimer );
	}
	hideTimer = window.setTimeout("$('.fixed').css('display',''); hideTimer = false;", 1000);
}

//-->
</script>

Comment 148 José Jeria 2008-07-12 04:12:30 PDT
*** Bug 444871 has been marked as a duplicate of this bug. ***
Comment 149 John McCormick 2008-08-05 09:43:22 PDT
I guess I'm not really surprised that this is still open, and I'm even less surprised that it's gotten so confused in comments. 

I wonder if it wouldn't be more helpful to open a new bug that targets this problem very specifically and doesn't have 5 years of confusion hampering it?

In any case, I'll try to summarize the problems that have been brought up and their status as far as I know:

1. Performance is worse when a page has fixed ELEMENTS (i.e. not a fixed background). Performance decreases as the number of fixed elements grows. I believe this is still an issue and will include my evidence in the following comment. 

2. Performance was worse when a page has the background-attachment: fixed CSS property applied. This problem is bug 90198. It is AFAIK totally unrelated to the current bug, and it seems that it doesn't generally affect people anymore.

3. On Windows, performance was worse when other windows were on top of the Firefox viewport. This seems to have been fixed since comment 24.

4. I think there's a problem where having opened enough images, pages, or other applications causes a sudden and drastic drop in scrolling performance (see bug 90198 comment 21). This is what I was talking about in comment 6, and haven't since been able to reproduce. It is NOT this bug.

5. Any slow/CPU-intensive scrolling is more so with smooth scrolling enabled. This is either common sense or a different bug, depending on your viewpoint.

6. Slow scrolling with large tables is bug 421601 and is totally unrelated, except that they can be used to emphasize the perf difference between a page w/ and w/o fixed elements.

7. Slow scrolling with resized images is bug 163975 and is totally unrelated, except that it can be used to emphasize the perf difference between a page w/ and w/o fixed elements.

Did I miss anything?

If we're going to leave this open, let's just focus on THIS bug and stop getting hung up on the other things that exacerbate it.
Comment 150 John McCormick 2008-08-05 09:49:06 PDT
Regarding the slowdown encountered when scrolling pages with fixed elements (item 1 in the prior comment) ONLY:

This is apparently still an "issue" on my machine. Here's how I tested:
With smooth scrolling off;
Scrolling by holding down the Down Arrow key on the keyboard;
On a system w/ WinXP, Athlon 64 X2 6000+, nVidia GeForce 8800GTS;
Under build Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.1) Gecko/2008070208 Firefox/3.0.1;

Using attachment 133309 [details] w/ static menu, (0 fixed elements) CPU usage is ~0%.
Using attachment 133309 [details] w/ fixed menu, (1 fixed element) CPU usage caps at ~4%.
Using attachment 170761 [details] (100 fixed elements) CPU usage caps at ~11%.

It is my opinion (@Gérard, Dimitrios) that the above testcases are simplified and demonstrate this problem effectively. I do not believe that there is a need for any additional testcases on THIS BUG. Some later testcases make this behavior more apparent by combining it with other problems (attachment 326909 [details]), but are not really necessary.


I can't say whether the above performance numbers are acceptable or unacceptable; it only demonstrates that the engine must do much more work to render pages with fixed elements. 

This isn't a problem for me since I have a very powerful computer, but (particularly when exacerbated by the other bugs mentioned above) may be a problem for older or less capable computers like the EeePC or iPhone.
Comment 151 Hasan Ceylan 2008-08-18 22:33:16 PDT
I think I have a clue for the reason some people here experience this problem as a small problem but some as a big problem. The reason is, the bigger the viewport, the worse the the situation is. 

I have a Core 2 Duo 2,6GHz CPU, 4 GB RAM, nVidia Corporation Quadro FX 1600M (Tried both closed source / open source drivers W/ 3D available / not available) laptop. That is a monster laptop. The screen resolution is 1920x1200. Computer is running Fedora 9 / 10.alpha W/ Gnome. I tried 2.22 & 2.23 gnome / gtk versions.

Firefox is Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.0.1) Gecko/2008072301 Fedora/3.0.1-1.fc10 Firefox/3.0.1

Now, I get very different performance between the states Firefox maximized and Firefox is 800x600 sized.

The sample site is http://dev.xwiki.org/xwiki/bin/view/Main/
The values are given for 800x600 | ~1920x1200 window sizes.

Below are the comments for the QA


> 1- How many of you have smooth scrolling on?

off | off

> 2- "dead slow", "horrible", "unbearable", etc.. are very subjective adjectives
almost no lag | 10 sec
> 4- How many of you are mentioning webpages which have hundreds of validation
Only 2 HTML errors with '&' are not escaped as '&apm';


> 5- How many of you are mentioning webpages that have lots of images, which are
N/A

> 6- How many of you are mentioning webpages which would be considered - anyway

No

> 7- "'position: fixed;' is very importan for top menu on intranets": Do 

Only 1 fixed div

> 8, 9, 10, 11, 12

Now, I have got an objection here. Do the users, trying to help you out here, have to be the QA people for Mozilla or does Mozilla have a bunch of QA people, who can constitute good test cases out of information available. People, I see here are positively trying to help Firefox solve this issue. I think rather then storming at them, the time and efforts put by them should be appreciated.  

Rather then expecting them to have the QA approach, expecting them to answer further questions should be enough.

And one last note I do not know excatly what that means but here is an excerpt from the bug header:
"QA Contact:  	  Hixie (not reading bugmail)"

Regards,
Hasan Ceylan

Comment 152 Rene Herman 2008-08-19 00:13:15 PDT
My main bug entry is 372039. Most information at #30 there.

But just to get the information here as well -- I'm on Linux, screen size does not seem to matter and there's nothing subjective about "unbearably slow". Trust me; after letting go of the scrollwheel, it can even take up to 10 real seconds for it to stop scrolling. Smooth scrolling is off.

The webpage I'm mentioning as one of the very clearly affected ones:

http://www.bnrmetal.com/v2/search.php?name=black+sabbath

(all band pages there).

Given that I'm quite decidedly not a web-designer, I suppose there are better candidates for enumerating its properties.

With Firefox 2.0.0.15 (to which I've retreated due to this issue) some laggyness can also be observed there but it's much better; in the sense that I hadn't even noticed it before Firefox 3 appeared and undeniably pointed out the problem

The "on Linux" bit may be relevant or not; I haven't a Windows box to test this with. Box on which I am with Linux is (as said in the other bug) an AMD Duron 1300 which is probably slower than most Firefox 3 users use and might account for me seeing the issue at all sizes and on many sites.

Opera 9.5 is lightning fast on all of them by the way.
Comment 153 John McCormick 2008-09-04 08:16:21 PDT
For what it's worth, under my setup (see comment 150) the above site uses 40%, then 20% of the total processing power on my machine during scrolling (it changes about 1/4 of the way down) and has a very noticeable back-and-forth visual jerk at the bottom.

I realize completely that such a live site without a reduced test case (which we already have) isn't very useful. But, it's an interesting real-life example of how this issue and others can collide to yield exceptionally poor performance.
Comment 154 Cory Dodt 2008-10-05 10:27:21 PDT
bug 427431 offers a possible solution.  Have any of the Linux devs looked into that?
Comment 155 Mardeg 2008-11-18 01:56:22 PST
*** Bug 455667 has been marked as a duplicate of this bug. ***
Comment 156 Cory Dodt 2008-12-21 23:34:56 PST
For FF 3.1b2:

   Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2

This appears to be finally fixed.  I was able to see the problem on all of the test sites; all of them are now MUCH faster.  Possibly tracemonkey?
Comment 157 Michael Balzer 2008-12-27 17:37:12 PST
Created attachment 354574 [details]
testcase from real-world intranet with just one fixed div

No, this issue is NOT fixed with FF3.1b2 -- just checked.

Test system: Just upgraded my laptop to openSuSE 11.1 (kernel 2.6.27.7-9-default, xorg-x11-server-7.4-17.3, gnome-desktop-2.24.1-2.16, ATI Mobility Radeon 9600 M10 RV350 with open source driver xorg-x11-driver-video-radeonhd-1.2.3_081202_ed532a7-1.1 (closed source does not work)).

First checked with FF3.0.5, then after reading the updates here with FF3.1b2: Same results.

See attached testcase for our simplified intranet support ticket form. The fixed div in reality contains common text modules for our customer support.

I intentionally left the scrolling content "complex" (table with form elements) to retain a measurable difference:

FF3.0.5 and FF3.1b2:
 Scrolling top-bottom: 7 seconds
 ...with fixed div outside visible window area: 3 seconds

FF2.0.0.20:
 3 seconds, no matter if the div is visible or not

You may say 7 seconds over 3 is not that much a difference, but a) it feels much worse when scrolling by mouse wheel and b) it adds if you're working on lots of tickets a day. I let two of our support staff members check the FF3 test setup and both said it's unacceptably slow.

Just a thought about all these WFM messages in the bug history: I'd say this is a clue where to seek the bug. It seems to me this bug occurs only with certain graphics drivers. So if the FF3 rendering engine uses other low level functions for scrolling than FF2, i'd suggest testing if these functions perform well with all graphics drivers. Maybe one of these low level functions is rarely used from other applications and thus poorly optimized with some graphics drivers.
Comment 158 Mardeg 2009-01-18 00:33:51 PST
*** Bug 474183 has been marked as a duplicate of this bug. ***
Comment 159 Zéfling 2009-03-21 17:30:46 PDT
I have : Win XP - AMD A64 3800+ - 1 Go - VIA/S3G DeltaChrome IGP

I use a complexe CSS menu on my website ( http://ikilote.net ) with transparent images.

The scroll is a little slow on Firefox 3.0.7 and it's worse on 3.5b3. On other webbrowser it's not slow.
Comment 160 Eugene R. Miller 2009-03-22 17:16:20 PDT
I think this might have something to do with the nvida video card.  On my laptop things scroll fine, and on my desktop it's VERY slow.
Comment 161 Stephan Sokolow 2009-03-22 19:57:08 PDT
Quite possibly. All the machines I use have nVidia cards. If that's the case, then there are two questions to be asked:

1. What do the nVidia drivers do wrong that Firefox depends on?
2. What do other browsers do which dodges the problem?
Comment 162 Rene Herman 2009-03-23 01:32:42 PDT
No, it's not (intrinsically) tied to nVidia. I used to experience this on Matrox G550, am now experiencing it on integrated Intel 865G.
Comment 163 Ildar Nurislamov 2009-03-23 01:52:51 PDT
(In reply to comment #160)
> I think this might have something to do with the nvida video card.  On my
> laptop things scroll fine, and on my desktop it's VERY slow.

Maybe you laptop with Vista OS
and desktop with XP. 

I have information that same browsers renders pages with fixed elements on Vista much faster that on XP. 
Maybe it is because new 2D infrastructure in vista.
Comment 164 Tomasz Sałaciński 2009-03-23 03:45:28 PDT
It's not tied to NVIDIA or Vista... on my Linux computer with NVIDIA graphics card Firefox works very fast, when on Vista computer with NVIDIA card scrolling on such pages is slow. I have 512MB of RAM on my graphics card on Linux computer, and 256MB RAM on Vista computer - maybe this is the issue? I've also noticed, that Firefox's performance drops dramatically when not on default zoom level.

I have lags when page is shrinked or enlarged, but when it's on defualt zoom (CTRL+0) it works perfectly.

I think this bug is tied to slow zooming on Linux and slow performance when zoom level is not at default (https://bugzilla.mozilla.org/show_bug.cgi?id=468726).
Comment 165 Stephan Sokolow 2009-03-23 14:09:43 PDT
My brother's got 1GiB of VRAM on Vista and he still has this problem at roughly the same level that I have with 256MiB on Linux.

However, I have noticed that Firefox is a lot more sensitive than other browsers to the optimizations for composited desktops on Linux. Konqueror, Opera, and friends work like a charm no matter how video is configured. Firefox's normal operation was sluggish enough to drive me nuts (as its normal state of being) until I finally combined Firefox 3, KWin 4.x compositing, and the tweaks to the nVidia drivers to make compositing work acceptably fast.
Comment 166 Robert O'Callahan (:roc) (email my personal email if necessary) 2009-03-23 14:29:44 PDT
On Linux, it's quite likely that our "sensitivity" is because we use cairo's X backend (i.e. depend on Xrender and friends), but other browsers do their rendering in software and just send over complete bitmaps.
Comment 167 Tomasz Sałaciński 2009-03-23 15:24:20 PDT
(In reply to comment #166)
> On Linux, it's quite likely that our "sensitivity" is because we use cairo's X
> backend (i.e. depend on Xrender and friends), but other browsers do their
> rendering in software and just send over complete bitmaps.

Not true, WebKitGTK does the whole rendering in Cairo too and it's ten times faster than Firefox on Linux (but less stable). Take a look at Midori and compare the rendering speed and zoom speed.
Comment 168 Robert O'Callahan (:roc) (email my personal email if necessary) 2009-03-23 18:10:03 PDT
Is it using the cairo X backend or the image backend?
Comment 169 Tomasz Sałaciński 2009-03-23 23:58:26 PDT
To be honest, I don't know. They just state they have Cairo graphics backend for GTK port, as they state here (under Shared Code Modules, it seems they are using it for image and SVG rendering):

http://trac.webkit.org/wiki/HackingGtk

For me, with the newest NVIDIA drivers for Linux, problem doesn't exist if the fixed element is an image(like fixed background). If the fixed element contains some text, it starts to get laggy, and if I resize the page (doesn't matter if I enlarge or shrink it) the scrolling is very laggy.

The problem on Linux starts here:

- resize the page: everything will start working a lot slower
- resize text only: everything is ok
- resizing takes a lot of time (few secs to resize Wikipedia once to a certain level, where Opera can do 7-8 resizes a second to make it look smooth). It seems Firefox doesn't reuse the fonts it loaded, it just loads them on every resize until they'll get cached in memory.

I think the worst problem exists with fonts and Pango backend - Firefox 2 behaved this way, using MOZ_DISABLE_PANGO=1 helped A LOT. But there is no way of disabling this in FF3. I believe this is the source of other bugs (like this one).
Comment 170 Robert O'Callahan (:roc) (email my personal email if necessary) 2009-03-24 00:52:16 PDT
Try a nightly trunk build, font caching and text resizing has improved a lot there.
Comment 171 Tomasz Sałaciński 2009-03-24 04:00:25 PDT
(In reply to comment #170)
> Try a nightly trunk build, font caching and text resizing has improved a lot
> there.

Just tried it. Can't wait for Firefox 3.5!

Works still slower than Opera, but it's like 10 times faster than it was on Firefox 3.1, which had problems resizing plain google site (1-2 sec delay). Now it's SMOOTH. Web surfing is smooth and convenient with new FF. And that's how it's supposed to work. Great job!
Comment 172 Mardeg 2009-06-07 06:00:12 PDT
*** Bug 496786 has been marked as a duplicate of this bug. ***
Comment 173 Zéfling 2009-06-22 02:10:54 PDT
With Firefox 3.5 R1, in fullscreen mode [F11] the scroll is normal, but with the interface, the scroll is slow.
Comment 174 Ryan Jones 2010-07-17 01:53:09 PDT
I can no longer reproduce the slow scrolling effects with the latest hourlies.

If anyone spots any particular test cases here that are still slow and lagging please file a new bug against bug 564991.

Fixed by bug 564991.

Note You need to log in before you can comment on or make changes to this bug.